<?php
/**
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program;
if not, write to the
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2012
sirfragalot@users.sourceforge.net
*/
/**
* CMS
*
* Content Management System hooks.
* 
* @version	1
*
*	@package wikindx4
*	@author Mark Grimshaw <sirfragalot@users.sourceforge.net>
*
*/
// Check we have a sane environment or die
include_once("core/startup/FACTORY.php");
include_once("core/startup/GLOBALS.php");
$config = FACTORY_CONFIG::getInstance();
if(!isset($config->WIKINDX_CMS_ALLOW) || !isset($config->WIKINDX_CMS_BIBSTYLE))
	die("Missing configuration");
if(!$config->WIKINDX_CMS_ALLOW) // deny access
	die("CMS access denied by WIKINDX configuration");

include_once("core/modules/cms/CMS.php");
$cms = new CMS();

// Check if request is to parse text for [cite]...[/cite tags
if(($_GET['action'] == 'parseText') && (!array_key_exists('address', $_GET) || !$_GET['address']))
	die('Missing or incorrect queryString');
else if($_GET['action'] == 'parseText')
{
	print CMS::parseText();
	die;
}
else if($_GET['action'] == 'parseSql')
{
	print $cms->parseSQL();
	die;
}
// Force HTTP to UTF-8 charset overriding any AddDefaultCharset set in Apache.
@header('Content-type: text/html; charset=utf-8');
// Following for display of resources
print CMS::queryDb();
die;

/**
END SCRIPT
*/

?>