<?php
/**********************************************************************************
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms 
of the GNU General Public License as published by the Free Software Foundation; either 
version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; 
if not, write to the 
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2013
sirfragalot@users.sourceforge.net
**********************************************************************************/
/**
*
* WIKINDX v4.x CONFIGURATION FILE
*
* NB. BEFORE YOU MAKE CHANGES TO THIS FILE, BACK IT UP!
* NB. BEFORE YOU MAKE CHANGES TO THIS FILE, BACK IT UP!
* NB. BEFORE YOU MAKE CHANGES TO THIS FILE, BACK IT UP!
*
* If you make changes, backup the edited file as future upgrades of WIKINDX will write over this file - no questions asked!
*/

/**********************************************************************************/

class CONFIG
{
/*****
START GENERAL CONFIGURATION
*****/
// The default timezone.  This should be set to the timezone of your server installation.  A list of valid timezones can be found at:
// http://www.php.net/manual/en/timezones.php
//  If not set, the timezone is set to UTC.
public $WIKINDX_TIMEZONE = 'UTC';
/*****
END GENERAL CONFIGURATION
*****/

/**********************************************************************************/

/*****
START DATABASE CONFIGURATION
*****/
// NB:
// The database and permissions for accessing it must be created using your RDBMS client. Wikindx
// will NOT do this for you.  If unsure how to do this, contact your server admin. After you have 
// set up an empty database with the correct permissions (GRANT ALL), the first running of Wikindx 
// will create the necessary database tables.
//
// WIKINDX uses caching in the database _cache table for lists of creators, keywords etc.  If you have a large 
// database, you may get SQL errors as WIKINDX attempts to write these cache data.  You will need to increase 
// max allowed packet in my.cnf and restart the MySQL server.
//
// Host on which the relational db management system (i.e. the MySQL server) is running (usually localhost if
// the web files are on the same server as the RDBMS although some web hosting services may specify something like 
// localhost:/tmp/mysql5.sock)
public $WIKINDX_DB_HOST = "localhost";
// name of the database which these scripts interface with:
public $WIKINDX_DB = "wikindx4";
// username and password required to connect to and open the database (it is strongly 
// recommended that you change these default values):
public $WIKINDX_DB_USER = "wikindx";
public $WIKINDX_DB_PASSWORD = "wikindx";
// If using WIKINDX on a shared database, set the WIKINDX table prefix here (do not change after running WIKINDX and creating the tables!):
public $WIKINDX_DB_TABLEPREFIX = 'WKX_';
// This version only supports 'mysql' so do not change this.
public $WIKINDX_DB_TYPE = "mysql";
// WIKINDX uses MySQL persistent connections by default.  Some hosting services are not configured for this: if you have problems 
// connecting to your MySQL server and/or receive error messages about 'too many connections', set $WIKINDX_DB_PERSISTENT to FALSE
public $WIKINDX_DB_PERSISTENT = TRUE;
/*****
END DATABASE CONFIGURATION
*****/

/**********************************************************************************/

/*****
START AUTHORIZATION CONFIGURATION
*****/
// SET $WIKINDX_RESTRICT_USERID to a user ID (see database) to stop this write-enabled user changing login details. 
// Typically this is used for a guest/test user (as on the WIKINDX testdrive database). Set to FALSE to disable.

public $WIKINDX_RESTRICT_USERID = FALSE;
/*****
END AUTHORIZATION CONFIGURATION
*****/

/**********************************************************************************/

/******
START SESSION CONFIGURATION
******/
// On some web-hosting services, disk quotas are set on session storage directories.  WIKINDX is a heavy user of sessions and the folder set for storing session data may fill up 
// quickly causing session write errors.  
// Additionally, large numbers of old session files can cause significant slow-down of the system.  See here for a report on the problem: https://sourceforge.net/projects/wikindx/forums/forum/326884/topic/4477010
// This variable sets an alternate path for storing sessions (which can be in your home directory).  If this variable does not exist or has no 
// value, the default session  path, as set in php.ini, will be used.  If it exists and has a value, the directory must exist and be writable by the web server user.
// There should be no trailing '\' or '/'.
// Example for a windows system:
// public  $WIKINDX_SESSION_PATH = "D:\sessions";

// If $WIKINDX_SESSION_PATH is set, this value will remove sessions in that directory older than xx days.  Set to 0 to never remove sessions.
// The value will be ignored if $WIKINDX_SESSION_PATH does not exist or is empty.
public $WIKINDX_SESSION_PATH_CLEAR = 10;
/******
ENDSESSION CONFIGURATION
******/

/**********************************************************************************/

/******
START DIRECTORY PATH CONFIGURATION
******/
// Alternate locations for storing attachments and exported files.  If these do not exist or are commented out, the default locations at the 
// top level of wikindx4/ will be used.  It is the adminstrator's responsibility to ensure that these directories are web-server user readable and writeable.
// There should be no trailing '\' or '/'.
// public $WIKINDX_ATTACHMENTS_DIR = "D:\attachments";
// public $WIKINDX_FILES_DIR = "D:\files";
// The TinyMCE editor needs the WIKINDX server installation path.  WIKINDX tries to get this through getcwd() but this is not always possible. In this case, 
// you will receive an error message and WIKINDX will die and you should then set that path here.  The path should be the full path from the root folder 
// to your wikindx4 folder with no trailing '/'.  On Apple OSX running XAMPP, for example, the case-sensitive path is: 
// '/Applications/XAMPP/xamppfiles/htdocs/wikindx4'.
// The script will continue to die until it has a valid installation path.
// If you get no error message and WIKINDX runs fine, then you can leave this value as FALSE.
public $WIKINDX_WIKINDX_PATH = FALSE;
/******
END DIRECTORY PATH CONFIGURATION
******/

/**********************************************************************************/

/*****
START PHP MEMORY AND EXECUTION CONFIGURATION
*****/
// WIKINDX usually runs with the standard PHP memory_limit of 32MB.  With some PHP configurations, however, this is not enough -- a mysterious 
// blank page is often the result.  If you are unable to update php.ini's memory_limit yourself, $WIKINDX_MEMORY_LIMIT may be set (an integer 
// such as 64 or 128 followed by 'M').  Despite the PHP manual stating that this may not be set outside of php.ini, it 
// seems to work most of the time.  It is not, however, guaranteed to do so and editing php.ini is the preferred method particularly if your 
// PHP is in 'safe' mode.
public $WIKINDX_MEMORY_LIMIT = "32M";
// WIKINDX should run fine with the PHP standard execution timeouts (typically 30 seconds) but, in some cases such as database upgrading of a 
// large database on a slow server, you will need to increase the timeout figure.  If this is FALSE, the value set in php.ini is used.  
// Despite the PHP manual stating that this may not be set outside of php.ini, it seems to work most of the time.  It is not, however, 
// guaranteed to do so and editing php.ini is the preferred method particularly if your PHP is in 'safe' mode.  Enter the value as "30" 
// for 30 seconds.
public $WIKINDX_MAX_EXECUTION_TIMEOUT = FALSE;
/*****
END PHP MEMORY AND EXECUTION CONFIGURATION
*****/

/**********************************************************************************/

/*****
START RESOURCE TYPE CONFIGURATION
*****/
// Deactivate resource types.  Simply uncomment those resource types that you wish to be disabled.
// Deactivated resource types that are already in the database will not have their display affected.
// The importing and exporting of bibliographies will ignore deactivated resource types in this list.
public $WIKINDX_DEACTIVATE_RESOURCE_TYPES = array(
// 'book',
// 'book_article',
// 'journal_article',
// 'newspaper_article',
// 'magazine_article',
// 'proceedings',
// 'conference_paper',
// 'conference_poster',
// 'proceedings_article',
// 'thesis',
// 'web_article',
// 'film',
// 'broadcast',
// 'music_album',
// 'music_track',
// 'music_score',
// 'artwork',
// 'software',
// 'audiovisual',
// 'database',
// 'government_report',
// 'report',
// 'hearing',
// 'statute',
// 'legal_ruling',
// 'case',
// 'bill',
// 'patent',
// 'personal',
// 'unpublished',
// 'classical',
// 'manuscript',
// 'map',
// 'chart',
// 'miscellaneous',
// 'miscellaneous_section',
// 'web_site',
// 'book_chapter',
// 'web_encyclopedia',
// 'web_encyclopedia_article',
// 'brochure',
);
/*****
END RESOURCE TYPE CONFIGURATION
*****/

/**********************************************************************************/

/*****
START  RSS CONFIGURATION (see rss.php)
*****/
// These are only required if you wish to run a RSS news feed for the latest additions to your WIKINDX.  See README_RSS.
// If $WIKINDX_RSS_ALLOW is FALSE, WIKINDX will block RSS access and will not display any RSS icon in the Firefox location bar.
// To allow RSS feed users to then click on the RSS link and access WIKINDX, $WIKINDX_DENY_READONLY must be FALSE.
public $WIKINDX_RSS_ALLOW = FALSE;
// No. of items to send to the feed.
public $WIKINDX_RSS_LIMIT = 10;
// WIKINDX main address as a base for adding the resource view querystring.  This should be the full external hostname and path.
public $WIKINDX_RSS_HOST = "http://localhost/wikindx4/index.php";
// Bibliographic style (UPPERCASE one of the directory names in wikindx4/styles/bibliography/)
public $WIKINDX_RSS_BIBSTYLE = "APA";
// Set this to FALSE to display only recently added resources or to TRUE to display recently added AND edited resources.
public $WIKINDX_RSS_DISPLAY = TRUE;
// RSS Title
public $WIKINDX_RSS_TITLE = "WIKINDX";
// RSS Description
public $WIKINDX_RSS_DESCRIPTION = "My Wikindx";
// RSS Language.  See: http://www.rssboard.org/rss-language-codes
public $WIKINDX_RSS_LANGUAGE = "en";
/*****
END RSS CONFIGURATION
*****/

/**********************************************************************************/

/*****
START  EMAIL CONFIGURATION
*****/
// To enable WIKINDX's email services (and systems such as user registration relying upon email), set $WIKINDX_MAIL_SERVER to TRUE.  
// This relies on there being a mail server in php.ini.  Most web hosting services will have a mail server that WIKINDX can use.
// In a multi-user WIKINDX, if $WIKINDX_READONLYACCESS is TRUE, an 'Email resource to friend' hyperlink is shown when 
// viewing a single resource if $WIKINDX_MAIL_SERVER is TRUE.  This opens a pop-up window where the user can compose a message and 
// email the resource ID to a friend.
public $WIKINDX_MAIL_SERVER = FALSE;
// If $WIKINDX_MAIL_FROM is FALSE, the WIKINDX title will be used for email in the 'From: ' field.  However, some email hosts will not 
// accept email without a valid email address in $WIKINDX_MAIL_FROM.
public $WIKINDX_MAIL_FROM = FALSE;
// If $WIKINDX_MAIL_REPLYTO is FALSE, 'No-Reply' will be used for the 'Reply-to: ' field.
public $WIKINDX_MAIL_REPLYTO = FALSE;
// If required, enter the 5th mail field here (the return path -- possibly something like '-f postmaster@domain.dom' 
// including single-quotes).  Otherwise, or if unsure, leave $WIKINDX_MAIL_RETURN_PATH as FALSE.  Setting 
// $WIKINDX_MAIL_RETURN_PATH will override the mail.force_extra_parameters parameter in php.ini.
// See Feature Request at:  http://sourceforge.net/tracker/index.php?func=detail&aid=1835467&group_id=94435&atid=607913
public $WIKINDX_MAIL_RETURN_PATH = FALSE;
// It is highly recommmended that you install and use PEAR::Mail (http://pear.php.net/package/Mail/) especially if you have many 
// registered users and your resource write/edit notify options are active.  PEAR::Mail is more efficient than PHP's default mail() 
// particularly when handling multiple addresses.  PEAR::Mail requires that PEAR::Net_SMTP be installed too 
// (http://pear.php.net/package/Net_SMTP/).
// After installing PEAR::Mail, use it in preference to PHP's mail() function by setting $WIKINDX_PEARMAIL_USE to TRUE and 
// setting all other $WIKINDX_PEARMAIL_XXXX variables.
public $WIKINDX_PEARMAIL_USE = FALSE;
// PEAR::Mail can send mail using 'sendmail' (typically installed on *NIX servers) or by connecting directly to a 'smtp' server. Set 
// $WIKINDX_PEARMAIL_BACKEND to either 'sendmail' or 'smtp'.
public $WIKINDX_PEARMAIL_BACKEND = 'smtp';
//// PEAR::MAIL sendmail backend configuration:
// The default sendmail path is '/usr/bin/sendmail'
public $WIKINDX_PEARMAIL_SMPATH = '/usr/bin/sendmail';
// Additional parameters to pass to sendmail. Default is -i.
public $WIKINDX_PEARMAIL_SMARGS = '-i';
//// PEAR::MAIL SMTP backend configuration:
// The SMTP server to connect to.
public $WIKINDX_PEARMAIL_SMTPSERVER = 'localhost';
// The SMTP server port to connect to.
public $WIKINDX_PEARMAIL_SMTPPORT = '25';
// Set $WIKINDX_PEARMAIL_SMTPPERSIST to TRUE to keep the SMTP open for multiple calls
public $WIKINDX_PEARMAIL_SMTPPERSIST = FALSE;
// Whether or not to use SMTP authentication.  If TRUE, set username and password.
public $WIKINDX_PEARMAIL_SMTPAUTH = FALSE;
public $WIKINDX_PEARMAIL_SMTPUSERNAME = 'xxxx';
public $WIKINDX_PEARMAIL_SMTPPASSWORD = 'xxxx';
/*****
END EMAIL CONFIGURATION
*****/

/**********************************************************************************/

/*****
START  GOOGLE SCHOLAR CONFIGURATION
*****/
// Allow Google Scholar to index resources.
public $WIKINDX_GS_ALLOW = FALSE;
// If $WIKINDX_GS_ALLOW is TRUE, set WIKINDX_GS_ATTACHMENT to TRUE to only allow indexing if the resource has an 
// attachment (if multiple attachments, only the primary is used).
// In the WIKINDX configuration interface, if 'Allow only registered users to view file attachments' is checked, resource 
// attachments will always be disallowed to Google Scholar.
public $WIKINDX_GS_ATTACHMENT = TRUE;
/*****
END GOOGLE SCHOLAR CONFIGURATION
*****/

/**********************************************************************************/

/*****
START  CMS CONFIGURATION
*****/
// These are only required if you wish to use WIKINDX to print individual resources or lists directly to a Content Management System.  See README_CMS.
// If $WIKINDX_CMS_ALLOW is TRUE, any user, regardless of the access settings (see above) may use the WIKINDX CMS hooks as provided in 
// README_CMS to display WIKINDX content in their CMS.  If FALSE, WIKINDX will block access.
public $WIKINDX_CMS_ALLOW = FALSE;
// Bibliographic style (UPPERCASE one of the directory names in wikindx4/styles/bibliography/)
public $WIKINDX_CMS_BIBSTYLE = "APA";
// Users can send a SQL string to the database for more complex queries if $WIKINDX_CMS_ALLOW is TRUE AND $WIKINDX_CMS_SQL is TRUE.  
// If this is the case, and users (in their preferences) have set CMS to display, they will have a 'cms' link provided for resource 
// lists that will give them a base64-encoded text string to use in their CMS as they wish.  If you allow users to do this, 
// WIKINDX will access the database using a different username::password combination to what is usually used.  It is your 
// responsibility to ensure this user _only_ has SELECT privileges on the database otherwise you are at risk of users sending INSERT, 
// UPDATE, DROP, EXECUTE etc. SQL commands!
public $WIKINDX_CMS_SQL = FALSE;
public $WIKINDX_CMS_DB_USER = 'xxx';
public $WIKINDX_CMS_DB_PASSWORD = 'xxx';
/*****
END  CMS CONFIGURATION
*****/

/**********************************************************************************/

/*****
START  TAG CLOUD CONFIGURATION
*****/
// When browsing tag clouds (for example, Browse Keywords in the Resources menu), you can indicate the frequency of the data by a range of colours and 
// font sizes from low to high.
// Font colours should be given as a hexadecimal string without any leading '#' or '0x'.  Each pair of hexadecimal characters (using the characters 0-9 and a-f or A-F) 
// represents the amount of red, green and blue (RGB) in the final colour.  For example, 'ff0000' or 'FF0000' is bright red', '000000' is black (no colour), 'ffffff' is white 
// (all bright colours equally), '00ff00' is green and 'ff00ff' is purple (a mix of bright red and bright blue).  Other colours and their hexadecimal equivalents may be 
// found here:  http://www.siteprocentral.com/html_color_code.html.
// Font sizes are given in em values.
// NB the background colour and the way the hyperlinks are displayed are given in the template's CSS file as the classes 'browseLink' and 'browseParagraph'
public $WIKINDX_TAG_LOW_COLOUR = "f060f0";
public $WIKINDX_TAG_HIGH_COLOUR = "ff0000";
public $WIKINDX_TAG_LOW_SIZE = 0.8;
public $WIKINDX_TAG_HIGH_SIZE = 1.5;
/*****
END  TAG CLOUD CONFIGURATION
*****/

/**********************************************************************************/

/*****
START DEBUGGING CONFIGURATION

All these should be FALSE on a production server.
*****/
// WIKINDX_DEBUG_ERRORS and WIKINDX_DEBUG_SQL are set here and, if TRUE, override 
// WIKINDX_ERROR_REPORTING and WIKINDX_PRINT_SQL which are set in the wikindx configure interface 
// and stored in database variables in the config table (see core/startup/LOADCONFIG.php).
public $WIKINDX_DEBUG_ERRORS = FALSE;
public $WIKINDX_DEBUG_SQL = FALSE;
// WIKINDX_BYPASS_SMARTYCOMPILE if TRUE, the compiled Smarty templates are not used and the templates are compiled again for each server call. 
public $WIKINDX_BYPASS_SMARTYCOMPILE = FALSE;
/*****
END DEBUGGING CONFIGURATION
*****/
}
?>
