<?php
/**
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program;
if not, write to the
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2013
sirfragalot@users.sourceforge.net
*/
/**
* Load image icons used throughout WIKINDX
* 
* @version	1
*
*	@package wikindx4\core\display
*	@author Mark Grimshaw <sirfragalot@users.sourceforge.net>
*
*/
class LOADICONS
{
/** string */
private $templateDir;
/** string */
public $view;
/** string */
public $viewAttach;
/** string */
public $viewmeta;
/** string */
public $viewmetaAttach;
/** string */
public $edit;
/** string */
public $delete;
/** string */
public $bibtex;
/** string */
public $next;
/** string */
public $previous;
/** string */
public $cite;
/** string */
public $add;
/** string */
public $remove;
/** string */
public $toLeft;
/** string */
public $toRight;
/** string */
public $toBottom;
/** string */
public $toTop;
/** string */
public $quarantine;
/** string */
public $file;
/** string */
public $help;
/** string */
public $basketAdd;
/** string */
public $basketRemove;
/** string */
public $basketAddLink;
/** string */
public $basketRemoveLink;
/** string */
public $viewLink;
/** string */
public $addLink;
/** string */
public $removeLink;
/** string */
public $toLeftLink;
/** string */
public $toRightLink;
/** string */
public $toBottomLink;
/** string */
public $toTopLink;
/** string */
public $editLink;
/** string */
public $bibtexLink;
/** string */
public $deleleteLink;
/** string */
public $quarantineLink;
/** string */
public $helpLink;
/** array */
public $jscriptActions = array();
/** object */
private $messages;
/** object */
private $session;
/** boolean */
private $setupDone = FALSE;

/**
* LOADICONS
*/
    public function __construct()
    {
		$session = FACTORY_SESSION::getInstance();
		$this->messages = FACTORY_MESSAGES::getInstance();
        if(!$this->templateDir = $session->getVar("setup_Template"))
            $this->templateDir = "default";
// Sometimes a directory may have been removed but that language is still in the session or database preferences 
// ... fall back to default and hope it's still there ;)
        if(!is_dir("templates/" . $this->templateDir))
            $this->templateDir = "default";
		$this->next = $this->messages->text("resources", "next");
		$this->previous = $this->messages->text("resources", "previous");
		$this->cite = $this->messages->text("cite", 'cite');
		$this->add = $this->messages->text("misc", "add");
		$this->edit = $this->messages->text("misc", "edit");
		$this->delete = $this->messages->text("misc", "delete");
		$this->bibtex = $this->messages->text("misc", "bibtex");
		$this->view = $this->messages->text("misc", "view");
		$this->viewmeta = $this->messages->text("misc", "view");
		$this->viewAttach = $this->messages->text("misc", "view");
		$this->viewmetaAttach = $this->messages->text("misc", "view");
		$this->remove = $this->messages->text("misc", "remove");
		$this->quarantine = $this->messages->text("misc", "quarantine");
		$this->help = $this->messages->text("misc", "help");
		$this->file = $this->messages->text("misc", "download");
		$this->basketAdd = $this->messages->text("resources", "basketAdd");
		$this->basketRemove = $this->messages->text("resources", "basketRemove");
    }
/**
* Get icon info
*
* @param string $input
*/
   private function getIconInfo($input)
   {
		$html = FACTORY_HTML::getInstance();
		// check we have both icons directory and icons themselves
		$exists = $input . "Exists";
		$this->{$exists} = FALSE;
        if(is_dir("templates/".$this->templateDir."/icons"))
        {
			$extensionFile = '';
            if(is_file("templates/".$this->templateDir."/icons/$input.gif"))
            {
				$extensionFile = 'gif';
			}
            elseif(is_file("templates/".$this->templateDir."/icons/$input.png"))
            {
				$extensionFile = 'png';
			}
            elseif(is_file("templates/".$this->templateDir."/icons/$input.jpg"))
            {
				$extensionFile = 'jpg';
			}
            
            
            if($extensionFile != '')
            {
				// get image size data
				$size = GetImageSize("templates/" . $this->templateDir. "/icons/$input." . $extensionFile);
				if(!empty($size))
                {
					if(!empty($this->jscriptActions) && array_key_exists($input, $this->jscriptActions))
						$html->insertJscriptAction = $this->jscriptActions[$input];
						
                    $this->$input = $html->img("templates/" . $this->templateDir. "/icons/$input." . $extensionFile, 
                       	$size[0], $size[1], $this->$input);
					$this->{$exists} = TRUE;
					$this->jscriptActions = array(); // reset immediately
               }
            }
        }   
    }
/**
* Set up icons for display.  If $input is given run only that icon setup.
*
* @param string $input Default is FALSE
*/
	public function setupIcons($input = FALSE)
	{
		if($this->setupDone)
			return;
		if($input)
		{
			$this->$input = $this->messages->text("misc", $input);
			$this->getIconInfo($input);
			$exists = $input . 'Exists';
			$link = $input . 'Link';
			$this->{$link} = $this->{$exists} ? "imgLink" : "link";
			return;
		}
		$this->getIconInfo('view');
		$this->getIconInfo('add');
		$this->getIconInfo('remove');
		$this->getIconInfo('viewmeta');
		$this->getIconInfo('viewAttach');
		$this->getIconInfo('viewmetaAttach');
		$this->getIconInfo('edit');
		$this->getIconInfo('bibtex');
		$this->getIconInfo('delete');
		$this->getIconInfo('next');
		$this->getIconInfo('previous');
		$this->getIconInfo('file');
		$this->getIconInfo('toLeft');
		$this->getIconInfo('toRight');
		$this->getIconInfo('toBottom');
		$this->getIconInfo('toTop');
		$this->getIconInfo('quarantine');
		$this->getIconInfo('help');
		$this->getIconInfo('basketAdd');
		$this->getIconInfo('basketRemove');
		$this->viewLink = $this->viewExists ? "imgLink" : "link";
		$this->addLink = $this->addExists ? "imgLink" : "link";
		$this->removeLink = $this->removeExists ? "imgLink" : "link";
		$this->editLink = $this->editExists ? "imgLink" : "link";
		$this->deleteLink = $this->editExists ? "imgLink" : "link";
		$this->bibtexLink = $this->bibtexExists ? "imgLink" : "link";
		$this->nextLink = $this->nextExists ? "imgLink" : "link";
		$this->previousLink = $this->previousExists ? "imgLink" : "link";
		$this->fileLink = $this->fileExists ? "imgLink" : "link";
		$this->toLeftLink = $this->toLeftExists ? "imgLink" : "link";
		$this->toRightLink = $this->toRightExists ? "imgLink" : "link";
		$this->toBottomLink = $this->toBottomExists ? "imgLink" : "link";
		$this->toTopLink = $this->toTopExists ? "imgLink" : "link";
		$this->helpLink = $this->helpExists ? "imgLink" : "link";
		$this->basketAddLink = $this->addExists ? "imgLink" : "link";
		$this->basketRemoveLink = $this->removeExists ? "imgLink" : "link";
		$this->setupDone = TRUE;
	}
/**
* Reset the icon initialisation routines
*/
	public function resetSetup()
	{
		$this->setupDone = FALSE;
	}
}
?>
