<?php
/**
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program;
if not, write to the
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2012
sirfragalot@users.sourceforge.net
*/
/**
* Load the WIKINDX display template system
* 
* @version	1
*
*	@package wikindx4\core\display
*	@author Mark Grimshaw <sirfragalot@users.sourceforge.net>
*
*/
class TEMPLATE
{
/** object */
public $tpl;
/** object */
private $config;

/**
* TEMPLATE
*/
	public function __construct()
	{
		include_once("core/display/Smarty/libs/Smarty.class.php");
		include_once("core/display/Smarty/SmartyMenu/libs/SmartyMenu.class.php");
		$this->tpl = new Smarty;
		$this->config = FACTORY_CONFIG::getInstance();
//		$this->tpl->config_dir = "$template/configs";
	}
/**
* Called from CLOSE, this sets up the right template to use before the script is exited
*/
	public function loadTemplate()
	{
		$session = FACTORY_SESSION::getInstance();
		$db = FACTORY_DB::getInstance();
		$template = $session->getVar("setup_Template");
// template may have been disabled by admin
		if(!$template || !is_dir('templates/' . $template) || !file_exists('templates/' . $template . '/description.txt'))
		{
			if(array_search('configTemplate', $db->listFields('config')) === FALSE)
				$template = 'default';
			else
				$template = $db->fetchOne($db->select('config', 'configTemplate'));
			if(!$template) // at first install of a blank database
				$template = 'default';
			if(!$session->getVar('setup_ReadOnly'))
				$session->setVar("setup_Template", $template);
		}
		$this->tpl->template_dir = 'templates/' . $template;
		if($this->config->WIKINDX_BYPASS_SMARTYCOMPILE)
			$this->tpl->force_compile = TRUE;
		else
			$this->tpl->force_compile = FALSE;
		$this->tpl->compile_dir = "templates/compiled_templates/$template";
		if(is_dir("templates/compiled_templates/$template") === FALSE)
			mkdir("templates/compiled_templates/$template");
		$this->tpl->cache_dir = "$template/cache";
/**
* We use dynamic pages so certainly don't want caching!
*/
		$this->tpl->caching = FALSE;
//		$this->tpl->template_dir = $template ? 'templates/' . $template : 'templates/default';
		if($fh = fopen($this->tpl->template_dir . '/description.txt', "r"))
		{
			$index = 0;
			while(($line = fgets($fh)) !== FALSE)
			{
				if(!$index) // discard description line
				{
					++$index;
					continue;
				}
				else if($index == 1) // reduceMenuLevel
				{
					if($line == '1')
					{
						if($session->issetVar('setup_TemplateMenu'))
							$session->setVar('setup_ReduceMenuLevel', $session->getVar('setup_TemplateMenu'));
						else
							$session->setVar('setup_ReduceMenuLevel', 1);
					}
					else if($line == '1$') // the menu style cannot be overridden by the user
						$session->setVar('setup_ReduceMenuLevel', 1);
					else if($line == '2')
					{
						if($session->issetVar('setup_TemplateMenu'))
							$session->setVar('setup_ReduceMenuLevel', $session->getVar('setup_TemplateMenu'));
						else
							$session->setVar('setup_ReduceMenuLevel', 2);
					}
					else if($line == '2$') // the menu style cannot be overridden by the user
						$session->setVar('setup_ReduceMenuLevel', 2);
					else if($line == '0')
					{
						if($session->issetVar('setup_TemplateMenu'))
							$session->setVar('setup_ReduceMenuLevel', $session->getVar('setup_TemplateMenu'));
						else
							$session->setVar('setup_ReduceMenuLevel', FALSE);
					}
					else if($line == '0$') // the menu style cannot be overridden by the user
						$session->setVar('setup_ReduceMenuLevel', FALSE);
				}
				else if($index == 2) // pre text for menu items that were in a subSubmenu -- only valid for reduceMenuLevel == 1
					$session->setVar('setup_ReduceMenuLevelPretext', $line);
				++$index;
			}
			if($index == 1) // only one line to be read
			{
				if($session->issetVar('setup_TemplateMenu'))
					$session->setVar('setup_ReduceMenuLevel', $session->getVar('setup_TemplateMenu'));
				else
					$session->setVar('setup_ReduceMenuLevel', FALSE);
			}
		}
	}
/**
* read templates/ directory for template preferences and check we have a sane environment
*
* @return array
*/
	public function loadDir()
	{
		$handle = opendir('templates');
		while(FALSE !== ($dir = readdir($handle)))
		{
			if(is_dir('templates/' . $dir) 
				&& file_exists('templates/' . $dir . '/description.txt')
				&& file_exists('templates/' . $dir . '/display.tpl')
				&& file_exists('templates/' . $dir . '/content.tpl')
				&& file_exists('templates/' . $dir . '/footer.tpl')
				&& file_exists('templates/' . $dir . '/header.tpl')
				&& file_exists('templates/' . $dir . '/menu.tpl'))
			{
// read one line
				if($fh = fopen('templates/' . $dir . '/description.txt', "r"))
					$string = fgets($fh);
				if($string)
					$array[$dir] = $string;
			}
		}
// sort alphabetically on the key
		ksort($array);
		return $array;
	}
}
?>
