<?php
/**
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program;
if not, write to the
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2012
sirfragalot@users.sourceforge.net
*/
/**
* EXPORTBIBTEX
*/

require_once("core/importexport/EXPORTER.php");

/**
* Export BibTeX
* 
* @version	1
*
*	@package wikindx4\core\importexport
*	@author Mark Grimshaw <sirfragalot@users.sourceforge.net>
*
*/
class EXPORTBIBTEX extends EXPORTER
{
/** object */
private $db;
/** object */
private $map;

/**
* Extends EXPORTER
*/
	function __construct()
	{
		$this->db = FACTORY_DB::getInstance();
		$this->map = FACTORY_BIBTEXMAP::getInstance();
	}

/** 
 * display bibtex data for one resource (from resource lists)
 *
 * @param array $row
 * @param array $creators
 * @return string
 */
	public function export($row,$creators)
	{
		$this->creators = $creators;
        $this->entry = $this->authors = array();
		$genre = $authors = $entry = $url = $doi = FALSE;
		$type = $this->map->types[$row['resourceType']];

		$this->getData($row);

        if(!empty($this->entry))
            $entry = $this->convertEntry();
        if(!empty($this->authors))
            $authors = $this->convertEntryAuthors();

		//print_r($row);
		$ret = '@'.strtoupper($type)."{" . $row['resourceBibtexKey'] . "\n";
		$ret .= $authors;
		$ret .= $entry;
		$ret .= "\n}\n";
		return $ret;
	}

/**
* Convert raw array of data to bibtex format
*
* @return string 
*/
    protected function convertEntry()
    {
        $array = array();
        array_map(array($this, "uEncode"), $this->entry);
        foreach($this->entry as $key => $value)
            $array[] = "$key = $value";
        return join("\n", $array);
	}
/**
* call back for convertEntry()
*
* @param string $element
* @return string
*/
	protected function uEncode($element)
	{
		return $element;
	}
/**
* create author string
*
* @return string
*/
    private function convertEntryAuthors()
    {
        $array = array();
        return 'author = '.join(" and ", $this->authors) . "\n";
    }
}
?>
