<?php
/**
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program;
if not, write to the
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2013
sirfragalot@users.sourceforge.net
*/
/**
* PAGING Alphabetic paging of lists -- only used when ordering by creator or title or attachment file name
* 
* @version	1
*
*	@package wikindx4\core\lists
*	@author Mark Grimshaw <sirfragalot@users.sourceforge.net>
*
*/
class PAGINGALPHA
{
/** object */
private $db;
/** array */
private $vars;
/** object */
private $session;
/** object */
private $messages;
/** object */
private $html;
/** object */
private $template;
/** array */
public $pagingArray;
/** int */
public $sizePA;
/** string */
public $sqlTotal;
/** string */
public $countAlphaQuery;
/** int */
public $total;
/** int */
public $start;
/** string */
public $queryString;
/** string */
public $listType;   // set in LISTCOMMON::pagingStyle
/** string */
public $order;   // set in LISTCOMMON::pagingStyle
/** boolean */
public $nullFound = FALSE;
/** boolean */
public $metadata = FALSE;

/**
*	PAGING
*/
	public function __construct()
	{
		$this->db = FACTORY_DB::getInstance();
		$this->vars = GLOBALS::getVars();
		$this->session = FACTORY_SESSION::getInstance();
		$this->messages = FACTORY_MESSAGES::getInstance();
		$this->html = FACTORY_HTML::getInstance();
		$this->template = FACTORY_TEMPLATE::getInstance();
// last element is for creators or titles beginning with a non-English alphabetic character 
		$this->pagingArray = range('A', 'Z');
		$this->sizeOfPA = sizeof($this->pagingArray);
		array_push($this->pagingArray, '??');
		$this->getPagingStart();
	}
/**
* grab paging either from default or from session
*/
	public function getPaging()
	{
		$this->grabTotal();
		if($this->nullFound && ($this->order == 'creator'))
			array_unshift($this->pagingArray, '--'); // NULL creators
		if(empty($this->pagingArray))
			return;
//		if(!array_key_exists($this->start, $this->pagingArray))
//			$this->start = array_shift(array_keys($this->pagingArray));
/*		if($this->order == 'attachments')//// NB NB NB NB  To be done!
		{
			if($this->start > $this->sizeOfPA)
				$this->start = 0;
			if($this->start == $this->sizeOfPA) // '--'  force this to 26th element and display all non-alpha attachments at the end
				$this->db->condition[] = $this->db->upper(
				$this->db->replace($this->db->replace($this->db->replace($this->db->replace('resourceattachmentsFileName', 
				'{', ''), '}', '', FALSE), '"', '', FALSE), '\\\'', '', FALSE), FALSE) . ' ' . 
				$this->db->regexp(FALSE, '^[^A-Z]', FALSE);
			else
				$this->db->condition[] = $this->db->upper($this->db->formatFields('resourceattachmentsFileName'), FALSE) . ' ' . 
					$this->db->like(FALSE, $this->pagingArray[$this->start], '%');
		}
*/
		if(sizeof($this->pagingArray) > 1)
		{
			$viewMax = $this->session->getVar('setup_Paging');
			if($viewMax <= 0)
				$viewMax = 20; // a cludge
			$countStmt = base64_decode($this->session->getVar('sql_CountStmt'));
			if($this->order == 'title')
				$field = 'resourceTitleSort';
			else if($this->order == 'creator')
			{
				if(strpos($countStmt, 'WKX_c') !== FALSE)
					$field = 'c.resourcecreatorCreatorSurname';
				else
					$field = 'resourcecreatorCreatorSurname';
			}
			else if($this->order == 'attachments')
				$field = 'resourceattachmentsFileName';
			foreach($this->pagingArray as $letter)
			{
// metadata uses unions so we must join the fields's table and construct the condition fully
				if($this->metadata)
				{
					if($letter == '??')
						$this->db->formatConditions($this->db->formatFields($field) . ' ' . $this->db->regexp(FALSE, '^[^A-Z]', FALSE));
					else if(($letter == '--') && ($this->order = 'creator'))
						$this->db->formatConditions($this->db->formatFields($field) . ' IS NULL ');
					else
						$this->db->formatConditions($this->db->upper($field) . ' ' .  $this->db->like(FALSE, $letter, '%'));
					$this->db->leftJoin('resource_creator', 'resourcecreatorResourceId', 'rId');
					$stmt = $countStmt;
				}
				else
				{
					if($letter == '??')
						$where = $this->db->formatFields($field) . ' ' . $this->db->regexp(FALSE, '^[^A-Z]', FALSE);
					else if(($letter == '--') && ($this->order = 'creator'))
						$where = $this->db->formatFields($field) . ' IS NULL ';
					else
						$where = $this->db->upper($field) . ' ' .  $this->db->like(FALSE, $letter, '%');
					$stmt = $countStmt . ' ' . $this->db->and . ' ' . $where;
				}
				$resultset = $this->db->query($stmt);
				$count = $this->db->fetchOne($resultset);
				$countArray[] = $count;
			}
			array_push($countArray, 0);
			$count = array_shift($countArray);
			$letter = array_shift($this->pagingArray);
			$letterArray = array();
			while($countArray)
			{
				if($count > $viewMax)
				{
					$newArray[] = array($letter);
					$count = array_shift($countArray);
					$letter = array_shift($this->pagingArray);
					continue;
				}
				$total = $count;
				while($total <= $viewMax)
				{
					if(!$letter)
						break;
					$letterArray[] = $letter;
					if(empty($countArray))
						break;
					$count = array_shift($countArray);
					$letter = array_shift($this->pagingArray);
					$total += $count;
				}
				$newArray[] = $letterArray;
				if(!empty($countArray))
					$letterArray = array();
			}
			if(isset($newArray))
				$this->pagingArray = $newArray;
		}
		else
		{
			$letter = array_shift($this->pagingArray);
			$newArray[] = array($letter);
			$this->pagingArray = $newArray;
		}
		$this->sizeOfPA = sizeof($this->pagingArray);
		$this->createLinks();
	}
/**
* Remove elements of $this->pagingArray where there are no resources and grab total resources
*/
	private function grabTotal()
	{
		if($this->order == 'creator')
			$tempPagingArray = array_fill(0, $this->sizeOfPA + 1, ''); // 'creator' separately lists resources without a creator to non-alpha creator surnames
		else
			$tempPagingArray = array_fill(0, $this->sizeOfPA + 1, '');
		$this->total = $this->db->fetchOne($this->sqlTotal);
		$count = 0;
		while($row = $this->db->fetchRow($this->countAlphaQuery))
		{
			$count++;
			if($this->order == 'title')
				$char = strtoupper(substr($row['resourceTitleSort'], 0, 1));
			else if($this->order == 'creator')
			{
				if($row['creatorSurname'])
					$char = strtoupper(substr($row['creatorSurname'], 0, 1));
				else
				{
					$this->nullFound = TRUE;
					continue;
				}
			}
			else if($this->order == 'attachments')
				$char = strtoupper(substr($row['resourceattachmentsFileName'], 0, 1));
			if(array_search($char, $tempPagingArray) !== FALSE) // already noted
				continue;
			if(($index = array_search($char, $this->pagingArray)) !== FALSE)
			{
				$tempPagingArray[$index] = $this->pagingArray[$index];
				continue;
			}
// If we get here, we have a creator or title with a non-English alphabetic character initially
			$tempPagingArray[sizeof($tempPagingArray) - 1] = '??';
		}
		foreach($tempPagingArray as $index => $element)
		{
			if(!$element)
				unset($this->pagingArray[$index]);
		}
	}
/**
* Links on display screen to move to more resources.
*
* $this->total is total resources found for this operation.
* $this->start is where we currently are.
*/
	private function createLinks()
	{
		if(sizeof($this->pagingArray) <= 1)
			return FALSE;
		$tempArray = $this->pagingArray;
		if(strpos($this->queryString, '?') !== FALSE)
			$rootFile = FALSE;
		else
			$rootFile = 'index.php?';
		foreach($this->pagingArray as $index => $array)
		{
			$array = array_shift($tempArray);
			if(sizeof($array) > 1)
				$chars = array_shift($array) . '~' . array_pop($array);
			else
				$chars = array_shift($array);
			if($this->start == $index)
				$links[] = $chars;
			else
			{
				$link = htmlentities($this->queryString . "&PagingStart=$index");
				$links[] = $this->html->a("page", "&nbsp;&nbsp;$chars&nbsp;&nbsp;", $rootFile . $link);
			}
		}
		if($this->session->getVar($this->listType . '_AscDesc') == 'DESC')
			$links = array_reverse($links);
		$this->template->tpl->assign('pagingList', $links);
	}
/**
* Format display information string
*
* @param string $bibTitle Default is FALSE
* @return string 
*/
	public function linksInfo($bibTitle = FALSE)
	{
		if(!$this->total)
			return $this->messages->text("resources", "noResult");
		$bib = FALSE;
		if(sizeof($this->pagingArray) == 1)
			$num = $this->total;
		else
		{
			$array = $this->pagingArray[$this->start];
			if(sizeof($array) > 1)
				$chars = array_shift($array) . '~' . array_pop($array);
			else
				$chars = array_shift($array);
			$num = "'" . $chars . "'";
		}
		if($bibTitle)
		{
			$bib = " (" . $this->messages->text("user", "bibliography") . ": " . 
			$this->html->dbToHtmlTidy($bibTitle) . ")";
		}
		else if($this->session->getVar('setup_MultiUser'))
			$bib = " (" . $this->messages->text("user", "bibliography") . ": " . 
				$this->messages->text("user", "masterBib") . ")";
		return $this->messages->text("hint", "pagingInfo", " $num&nbsp;") . 
			$this->messages->text("hint", "pagingInfoOf", $this->total . $bib);
	}
/**
* get paging start
*/
	public function getPagingStart()
	{
		if(!array_key_exists('PagingStart', $this->vars))
		{
			if($start = $this->session->getVar('mywikindx_PagingStart'))
				$this->start = $start;
			else
				$this->start = 0;
		}
		else
		{
			$this->session->setVar('mywikindx_PagingStart', $this->vars['PagingStart']);
			$this->start = $this->vars['PagingStart'];
		}
	}
}
?>
