<?php
/**
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program;
if not, write to the
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2012
sirfragalot@users.sourceforge.net
*/
/**
* GATEKEEP
*
* Test authority to do write operations.
* 
* @version	1
*
*	@package wikindx4\core\miscellaneous
*	@author Mark Grimshaw <sirfragalot@users.sourceforge.net>
*
*/
class GATEKEEP
{
/** object */
private $session;
/** object */
private $config;
/** boolean */
public $requireSuper = FALSE;

/**
* GATEKEEP class
*/
	public function __construct()
	{
		$this->session = FACTORY_SESSION::getInstance();
		$this->config = FACTORY_CONFIG::getInstance();
	}
/**
* Admins can do everything
* 
* Either return TRUE or the login prompt
* @param boolean $globalEdit If TRUE, config.php's $WIKINDX_GLOBAL_EDIT must be be set to TRUE. Default is FALSE
* @param boolean $originatorEditOnly If TRUE, config.php's $WIKINDX_ORIGINATOR_EDITONLY must be TRUE. Default is FALSE
*/
	public function init($globalEdit = FALSE, $originatorEditOnly = FALSE)
	{
		if($this->session->getVar("setup_Superadmin"))
			return TRUE;
		else if($this->requireSuper)
		{
			$authorize = FACTORY_AUTHORIZE::getInstance();
			$authorize->initLogon();
			FACTORY_CLOSENOMENU::getInstance(); // die
		}
		if($this->session->getVar('setup_Write'))
		{
			if($globalEdit && isset($this->config->WIKINDX_GLOBAL_EDIT) && !$this->config->WIKINDX_GLOBAL_EDIT)
			{
				$authorize = FACTORY_AUTHORIZE::getInstance();
				$authorize->initLogon();
				FACTORY_CLOSENOMENU::getInstance(); // die
			}
			if($originatorEditOnly && isset($this->config->WIKINDX_ORIGINATOR_EDITONLY) && 
				!$this->config->WIKINDX_ORIGINATOR_EDITONLY)
			{
				$authorize = FACTORY_AUTHORIZE::getInstance();
				$authorize->initLogon();
				FACTORY_CLOSENOMENU::getInstance(); // die
			}
			return TRUE;
		}
// Failure to authorize so provide logon prompt
		$authorize = FACTORY_AUTHORIZE::getInstance();
		$authorize->initLogon();
		FACTORY_CLOSENOMENU::getInstance(); // die
	}
}
?>
