<?php
/**
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program;
if not, write to the
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2012
sirfragalot@users.sourceforge.net
*/
/**
* TAG
*
* An import may be tagged so that the resources in it may be tracked in later list and delete operations.
* 
* @version	1
*
*	@package wikindx4\core\miscellaneous
*	@author Mark Grimshaw <sirfragalot@users.sourceforge.net>
*
*/
class TAG
{
/** object */
private $db;
/** object */
private $html;

/**
*	TAG class
*/
	public function __construct()
	{
		$this->db = FACTORY_DB::getInstance();
		$this->html = FACTORY_HTML::getInstance();
	}
/**
* Get tags from tag table.
*
* @return mixed FALSE|associative array of id => group.
*/
	public function grabAll()
	{
		$this->db->orderBy('tagTag');
		$recordset = $this->db->select('tag', array('tagId', 'tagTag'));
		while($row = $this->db->fetchRow($recordset))
			$tags[$row['tagId']] = $this->html->dbToFormTidy($row['tagTag']);
		if(isset($tags))
			return $tags;
		return FALSE;
	}
/**
* Does this tag already exist in the database?
*
* @param string $tag
* @return mixed FALSE|tag ID
*/
	public function checkExists($tag)
	{
		$this->db->formatConditions(array('tagTag' => $tag));
		$resultset = $this->db->select('tag', 'tagId');
		if($this->db->numRows($resultset))
			return $this->db->fetchOne($resultset);
		return FALSE; // not found
	}
}
?>
