<?php
/**********************************************************************************
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program;
if not, write to the
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2013
sirfragalot@users.sourceforge.net
**********************************************************************************/
/**
* LOADEXTERNALMODULES class for third-party plug-in modules in the plugins/ directory
*
*/
class LOADEXTERNALMODULES
{
public $moduleDirectory = 'plugins/';

	public function __construct()
	{
	}
// read root plugins/ directory for any available modules
	public function readPluginsDirectory()
	{
		$moduleExists = FALSE;
		if(!is_dir($this->moduleDirectory) || (!$handle = opendir($this->moduleDirectory)))
			return FALSE;
		while(FALSE !== ($dir = readdir($handle)))
		{
			$index = $this->moduleDirectory . $dir . '/index.php';
			$config = $this->moduleDirectory . $dir . '/config.php';
			$type = $this->moduleDirectory . $dir . '/plugintype.txt';
			if(is_dir($this->moduleDirectory . $dir) && file_exists($index) && file_exists($config)
				 && file_exists($type) && ($dir != '.') && ($dir != '..'))
			{
				if(!$this->checkVersion($this->moduleDirectory, $dir))
					continue;
				$moduleList[] = $dir;
				$moduleExists = TRUE;
			}
		}
		if($moduleExists)
			return $moduleList;
		else
			return FALSE;
	}
// Check version is compatible, if not, quietly exit
	private function checkVersion($moduleDirectory, $dir)
	{
		include_once($moduleDirectory . $dir . '/config.php');
		$class = $dir . "_CONFIG";
		$config = new $class();
		if(!isset($config->wikindxVersion))
			return FALSE;
		if($config->wikindxVersion != WIKINDX_PLUGIN_VERSION)
			return FALSE;
		return TRUE;
	}
}
?>
