<?php
/**********************************************************************************
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program;
if not, write to the
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2011
sirfragalot@users.sourceforge.net
**********************************************************/
/**
*	Quarantine and approve resources
*
*/
class QUARANTINE
{
private $session;
private $db;
private $vars;
private $gatekeep;
private $badInput;
private $errors;
private $navigate;
private $success;
private $messages;
private $stmt;
private $common;

	public function __construct()
	{
		$this->session = FACTORY_SESSION::getInstance();
		$this->db = FACTORY_DB::getInstance();
		$this->errors = FACTORY_ERRORS::getInstance();
		$this->success = FACTORY_SUCCESS::getInstance();
		$this->messages = FACTORY_MESSAGES::getInstance();
		$this->navigate = FACTORY_NAVIGATE::getInstance();
		$this->badInput = FACTORY_BADINPUT::getInstance();
		$this->stmt = FACTORY_SQLSTATEMENTS::getInstance();
		$this->common = FACTORY_LISTCOMMON::getInstance();
		$this->vars = GLOBALS::getVars();
		$this->gatekeep = FACTORY_GATEKEEP::getInstance();
		$this->gatekeep->requireSuper = TRUE;
	}
// Approve resource
	public function approve()
	{
		$this->gatekeep->init();
		if(!array_key_exists('resourceId', $this->vars))
			$this->badInput->close($this->errors->text("inputError", "missing"));
		$this->db->formatConditions(array('resourcemiscId' => $this->vars['resourceId']));
		$updateArray['resourcemiscQuarantine'] = 'N';
		$this->db->update('resource_misc', $updateArray);
		$this->navigate->resource($this->vars['resourceId'], $this->success->text("quarantineApprove"));
	}
// Quarantine resource
	public function quarantine()
	{
		$this->gatekeep->init();
		if(!array_key_exists('resourceId', $this->vars))
			$this->badInput->close($this->errors->text("inputError", "missing"));
		$this->db->formatConditions(array('resourcemiscId' => $this->vars['resourceId']));
		$updateArray['resourcemiscQuarantine'] = 'Y';
		$this->db->update('resource_misc', $updateArray);
		$this->navigate->resource($this->vars['resourceId'], $this->success->text("quarantined"));
	}
/**
* Quickly check if there are any quarantined resources (used in MENU)
*/
	public function checkQuarantine()
	{
		$this->db->formatConditions(array('resourcemiscQuarantine' => 'Y'));
		$resultset = $this->db->select('resource_misc', 'resourcemiscId');
		if($this->db->numRows($resultset))
			return TRUE;
		return FALSE;
	}
// List quarantined resources
	public function listQuarantined()
	{
		$this->gatekeep->init();
		GLOBALS::setOutputHeading($this->messages->text("heading", "quarantine"));
		$this->stmt->listQuarantined = TRUE;
		$this->stmt->listMethodAscDesc = $this->db->desc;
		$this->session->setVar('list_Method', 'timestamp');
		$queryString = 'action=admin_QUARANTINE_CORE&method=listQuarantined';
		$this->stmt->createTotalResourceSubqueryList(FALSE, FALSE, 'timestamp', TRUE, $queryString);
		if(array_key_exists('type', $this->vars) && ($this->vars['type'] == 'lastMulti'))
		{
			$sql = base64_decode($this->session->getVar('sql_Stmt'));
			$this->common->display($sql, 'list');
			$this->session->setVar("bookmark_DisplayAdd", TRUE);
			$this->session->saveState('list');
			$this->session->saveState('sql');
			$this->session->saveState('bookmark');
			return;
		}
		$sql = $this->stmt->listList(FALSE, FALSE, 'timestamp');
		$this->common->listQuarantined = TRUE;
		$this->common->display($sql, 'list');
// set the lastMulti session variable for quick return to this process.
		$this->session->setVar('sql_LastMulti', $queryString);
// Turn on the 'add bookmark' menu item
		$this->session->setVar("bookmark_DisplayAdd", TRUE);
		$this->session->saveState('list');
		$this->session->saveState('sql');
		$this->session->saveState('bookmark');
	}
}
?>
