/**********************************************************************************
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms 
of the GNU General Public License as published by the Free Software Foundation; either 
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; 
if not, write to the 
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2013
sirfragalot@users.sourceforge.net

**********************************************************************************/

/**
* Javascript functions for core/modules/amin/ADMINPLUGINS
*
* Not AJAX, but uses the WIKINDX AJAX framework for simplicity and efficiency
*
* @version 1.1
* @date February 2013
* @author Mark Grimshaw
*/

function disablePlugin()
{
	coreSelectToSelect('pluginsDisabled', 'pluginsEnabled');
}
function enablePlugin()
{
	coreSelectToSelect('pluginsEnabled', 'pluginsDisabled');
}
function disableStyle()
{
	coreSelectToSelect('stylesDisabled', 'stylesEnabled');
}
function enableStyle()
{
	coreSelectToSelect('stylesEnabled', 'stylesDisabled');
}
function disableLanguage()
{
	coreSelectToSelect('languagesDisabled', 'languagesEnabled');
}
function enableLanguage()
{
	coreSelectToSelect('languagesEnabled', 'languagesDisabled');
}
function disableTemplate()
{
	coreSelectToSelect('templatesDisabled', 'templatesEnabled');
}
function enableTemplate()
{
	coreSelectToSelect('templatesEnabled', 'templatesDisabled');
}
/**
* On submit, select all options in both enabled and disabled select boxes -- this allows PHP to pick up those options
*/
function selectAll()
{
	selectAllPlugins();
	selectAllStyles();
	selectAllLanguages();
	selectAllTemplates();
}
function selectAllPlugins()
{
	var objA = coreGetElementById('pluginsEnabled');
	var objB = coreGetElementById('pluginsDisabled');
	for(i = objA.options.length - 1; i >= 0; i--)
		objA.options[i].selected = true;
	for(i = objB.options.length - 1; i >= 0; i--)
		objB.options[i].selected = true;
}
function selectAllStyles()
{
	var objA = coreGetElementById('stylesEnabled');
	var objB = coreGetElementById('stylesDisabled');
	for(i = objA.options.length - 1; i >= 0; i--)
		objA.options[i].selected = true;
	for(i = objB.options.length - 1; i >= 0; i--)
		objB.options[i].selected = true;
}
function selectAllTemplates()
{
	var objA = coreGetElementById('templatesEnabled');
	var objB = coreGetElementById('templatesDisabled');
	for(i = objA.options.length - 1; i >= 0; i--)
		objA.options[i].selected = true;
	for(i = objB.options.length - 1; i >= 0; i--)
		objB.options[i].selected = true;
}
function selectAllLanguages()
{
	var objA = coreGetElementById('languagesEnabled');
	var objB = coreGetElementById('languagesDisabled');
	for(i = objA.options.length - 1; i >= 0; i--)
		objA.options[i].selected = true;
	for(i = objB.options.length - 1; i >= 0; i--)
		objB.options[i].selected = true;
}
