<?php
/**********************************************************************************
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program;
if not, write to the
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2010
sirfragalot@users.sourceforge.net
**********************************************************************************/
/**
* Provides interface for auto-suggestions from external programs and for Wikindx AJAX.
*/
class SUGGEST
{
	private $db;
	private $vars;
	private $config;
	private $stmt;
	private $errors;
	private $messages;
	private $session;
	private $user;
	private $badInput;
	private $allowEdit = FALSE;

	public function __construct()
	{
		$this->db = FACTORY_DB::getInstance();
		$this->vars = GLOBALS::getVars();
		$this->config = FACTORY_CONFIG::getInstance();
		$this->stmt = FACTORY_SQLSTATEMENTS::getInstance();
		$this->errors = FACTORY_ERRORS::getInstance();
		$this->messages = FACTORY_MESSAGES::getInstance();
		$this->session = FACTORY_SESSION::getInstance();
		$this->user = FACTORY_USER::getInstance();
		$this->badInput = FACTORY_BADINPUT::getInstance();
		GLOBALS::setOutputHeading($this->messages->text("heading", "resources"));
	}
	public function keywords()
	{
        if(!array_key_exists('param1', $this->vars) || !$this->vars['param1'])
            $this->badInput->close($this->errors->text("inputError", "missing"));

		$param1 = $this->vars['param1'];

		// the following is a hack, should be changed:
		$this->db->condition[] = "keywordKeyword LIKE ". $this->db->tidyInput("$param1%");
		$resultset = $this->db->select('keyword', 'keywordKeyword');

		if(!$this->db->numRows($resultset))
			$this->badInput->close($this->messages->text("resources", "noResult"));

		$quoted = array();
		while( $row = $this->db->fetchRow($resultset) )
		{
			$quoted[] = "\"" . $row['keywordKeyword'] . "\"";
		}
		self::displayRaw($param1,$quoted);
	}
	private function displayRaw($param1, $quoted) {	
		$body = "[\"$param1\",[";
		$body .= implode(",",$quoted);
		$body .= ']]';

		echo $body;
		FACTORY_CLOSERAW::getInstance();
	}
	public function authors()
	{
        if(!array_key_exists('param1', $this->vars) || !$this->vars['param1'])
            $this->badInput->close($this->errors->text("inputError", "missing"));

		$param1 = $this->vars['param1'];

		// the following is a hack, should be changed:
		$this->db->condition[] = "( creatorSurname LIKE ". $this->db->tidyInput("$param1%") .
		            " OR creatorFirstname LIKE ". $this->db->tidyInput("$param1%") . ')';
		$resultset = $this->db->select('creator', array('creatorFirstname','creatorSurname'));

		if(!$this->db->numRows($resultset))
			$this->badInput->close($this->messages->text("resources", "noResult"));
		
		$quoted = array();
		while( $row = $this->db->fetchRow($resultset) )
		{
			$quoted[] = "\"" . $row['creatorSurname'] .', '. $row['creatorFirstname'] . "\"";
		}
		self::displayRaw($param1,$quoted);
	}
	public function collections()
	{
        if(!array_key_exists('param1', $this->vars) || !$this->vars['param1'])
            $this->badInput->close($this->errors->text("inputError", "missing"));

		$param1 = $this->vars['param1'];

		// the following is a hack, should be changed:
		$this->db->condition[] = "( collectionTitle LIKE ". $this->db->tidyInput("$param1%") .
		            " OR collectionTitleShort LIKE ". $this->db->tidyInput("$param1%") . ')';
		$resultset = $this->db->select('collection', array('collectionTitle'));

		if(!$this->db->numRows($resultset))
			$this->badInput->close($this->messages->text("resources", "noResult"));
		
		$quoted = array();
		while( $row = $this->db->fetchRow($resultset) )
		{
			$quoted[] = "\"" . $row['collectionTitle'] . "\"";
		}
		self::displayRaw($param1,$quoted);
	}
}
?>
