<?php
/**********************************************************************************
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program;
if not, write to the
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2013
sirfragalot@users.sourceforge.net

**********************************************************************************/
/**
* BROWSECATEGORY class
*
* Browse categories as a 'tag cloud'
*
*/
class BROWSECATEGORY
{
private $db;
private $vars;
private $common;
private $html;
private $template;
private $messages;
public $category;
public $sum;
public $bib;

	public function __construct()
	{
		$this->db = FACTORY_DB::getInstance();
		$this->vars = GLOBALS::getVars();
		include_once("core/browse/BROWSECOMMON.php");
		$this->common = new BROWSECOMMON();
		$this->html = FACTORY_HTML::getInstance();
		$this->template = FACTORY_TEMPLATE::getInstance();
		$this->messages = FACTORY_MESSAGES::getInstance();
		GLOBALS::setOutputHeading($this->messages->text("heading", "browseCategory"));
	}
// display categories
	public function init()
	{
		$this->sum = $this->category = array();
		$this->getCategories();
		natcasesort($this->sum);
		$this->category = $this->common->paging($this->category);
		$this->common->linksInfo();
		$pString = $this->html->pBrowse($this->process(), "center");
		$this->common->pagingLinks('action=browse_BROWSECATEGORY_CORE');
		GLOBALS::buildOutputString($pString);
	}
// Get categories from db
	public function getCategories()
	{
		$this->common->userBibCondition('resourcecategoryResourceId');
		$this->db->formatConditions($this->db->formatFields('resourcecategoryCategoryId') . ' IS NOT NULL');
		$subQ = $this->db->subQuery($this->db->selectCountsNoExecute('resource_category', 'resourcecategoryCategoryId', 
			FALSE, FALSE, TRUE, TRUE), 't');
		$this->db->leftJoin('category', 'categoryId', 'resourcecategoryCategoryId');
		$this->db->orderBy('categoryCategory');
		$recordset = $this->db->selectFromSubQuery(FALSE, array('categoryId', 'categoryCategory', 'count'), $subQ);
		while($row = $this->db->fetchRow($recordset))
			$this->collate($row);
// Place 'General' first
		if(array_key_exists(1, $this->category))
		{
			$general[1] = $this->category[1];
			unset($this->category[1]);
		}
		foreach($this->category as $id => $category)
			$general[$id] = $category;
		$this->category = $general;
	}
// Add categories to array and sum totals
	private function collate($row)
	{
		$this->category[$row['categoryId']] = preg_replace("/{(.*)}/U", "$1", 
			$this->html->dbToHtmlTidy($row['categoryCategory']));
		$this->sum[$row['categoryId']] = $row['count'];
	}
// Process and display results
	private function process()
	{
		$lowestSum = current($this->sum);
		$highestSum = end($this->sum);
		foreach($this->category as $id => $name)
		{
			$colour = $this->common->colourText($lowestSum, $highestSum, $this->sum[$id]);
			$size = $this->common->sizeText($lowestSum, $highestSum, $this->sum[$id]);
			$links[] = $this->html->aBrowse($colour, $size, $name, 'index.php?' . 
				htmlentities('action=list_LISTSOMERESOURCES_CORE&method=categoryProcess&id=' . $id)) . 
				"&nbsp;[" . $this->sum[$id] . "]";
		}
		return join("&nbsp; ", $links);
	}
}
?>