<?php
/**********************************************************************************
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program;
if not, write to the
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2011
sirfragalot@users.sourceforge.net

**********************************************************************************/
/*****
* BROWSELANGUAGE class
*
* Browse resource languages as a 'tag cloud'
*
*****/
class BROWSELANGUAGE
{
private $db;
private $vars;
private $common;
private $html;
private $template;
private $messages;
private $languages = array();
private $sum;
private $bib;
private $form;
private $map;

	public function __construct()
	{
		$this->db = FACTORY_DB::getInstance();
		$this->vars = GLOBALS::getVars();
		include_once("core/browse/BROWSECOMMON.php");
		$this->common = new BROWSECOMMON();
		$this->html = FACTORY_HTML::getInstance();
		$this->template = FACTORY_TEMPLATE::getInstance();
		$this->messages = FACTORY_MESSAGES::getInstance();
		$this->form = FACTORY_FORM::getInstance();
		GLOBALS::setOutputHeading($this->messages->text("heading", "browseLanguage"));
	}
// display languages
	public function init()
	{
		$this->sum = array();
		$this->getLanguages();
		if(empty($this->languages))
		{
			GLOBALS::buildOutputString($this->messages->text("misc", "noLanguages"));
			return;
		}
		natcasesort($this->sum);
//		natcasesort($this->types);
		$this->languages = $this->common->paging($this->languages);
		$this->common->linksInfo();
		$pString = $this->html->pBrowse($this->process(), "center");
		$this->common->pagingLinks('action=browse_BROWSELANGUAGE_CORE');
		GLOBALS::buildOutputString($pString);
	}
// Grab any languages
	private function getLanguages()
	{
		$this->common->userBibCondition('resourcelanguageResourceId');
		$subQ = $this->db->subQuery($this->db->selectCountsNoExecute('resource_language', 'resourcelanguageLanguageId', 
			FALSE, FALSE, TRUE, TRUE), 't');
		$this->db->leftJoin('language', 'languageId', 'resourcelanguageLanguageId');
		$this->db->orderBy('languageLanguage');
		$recordset = $this->db->selectFromSubQuery(FALSE, array('languageId', 'languageLanguage', 'count'), $subQ);
		while($row = $this->db->fetchRow($recordset))
			$this->collate($row);
	}
// Add languages to array and sum totals
	private function collate($row)
	{
		$this->languages[$row['languageId']] = preg_replace("/{(.*)}/U", "$1", 
				$this->html->dbToHtmlTidy($row['languageLanguage']));
		$this->sum[$row['languageId']] = $row['count'];
	}
// Process and display results
	private function process()
	{
		$lowestSum = current($this->sum);
		$highestSum = end($this->sum);
		foreach($this->languages as $id => $name)
		{
			$colour = $this->common->colourText($lowestSum, $highestSum, $this->sum[$id]);
			$size = $this->common->sizeText($lowestSum, $highestSum, $this->sum[$id]);
			$links[] = $this->html->aBrowse($colour, $size, $name, 'index.php?' . 
				htmlentities('action=list_LISTSOMERESOURCES_CORE&method=languageProcess&id=' . $id)) . 
				"&nbsp;[" . $this->sum[$id] . "]";
		}
		return join("&nbsp; ", $links);
	}
}
?>