<?php
/**********************************************************************************
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program;
if not, write to the
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2013
sirfragalot@users.sourceforge.net

**********************************************************************************/
/**
* BROWSEUSERTAGS class
*
* Browse user tags as a 'tag cloud'
*
*/
class BROWSEUSERTAGS
{
private $db;
private $vars;
private $common;
private $html;
private $template;
private $messages;
public $category;
public $sum;
public $bib;

	public function __construct()
	{
		$this->db = FACTORY_DB::getInstance();
		$this->vars = GLOBALS::getVars();
		include_once("core/browse/BROWSECOMMON.php");
		$this->common = new BROWSECOMMON();
		$this->html = FACTORY_HTML::getInstance();
		$this->template = FACTORY_TEMPLATE::getInstance();
		$this->messages = FACTORY_MESSAGES::getInstance();
		$this->session = FACTORY_SESSION::getInstance();
		GLOBALS::setOutputHeading($this->messages->text("heading", "browseUserTags"));
	}
// display user tags
	public function init()
	{
		$this->sum = $this->userTags = array();
		$this->getUserTags();
		if(empty($this->userTags))
		{
			GLOBALS::buildOutputString($this->messages->text("misc", "noUsertags"));
			return;
		}
		natcasesort($this->sum);
		$this->userTags = $this->common->paging($this->userTags);
		$this->common->linksInfo();
		$pString = $this->html->pBrowse($this->process(), "center");
		$this->common->pagingLinks('action=browse_BROWSEUSERTAGS_CORE');
		GLOBALS::buildOutputString($pString);
	}
// Get user tags from db
	public function getUserTags()
	{
		$this->common->userBibCondition('resourceusertagsResourceId');
		$this->db->formatConditions(array('usertagsUserId' => $this->session->getVar('setup_UserId')));
		$this->db->leftJoin('user_tags', 'usertagsId', 'resourceusertagsTagId');
		$this->db->groupBy('usertagsId');
		$this->db->orderByCollate('usertagsTag');
		$recordset = $this->db->selectCounts('resource_user_tags', 'usertagsId', 'usertagsTag');
		while($row = $this->db->fetchRow($recordset))
			$this->collate($row);
	}
// Add user tags to array and sum totals
	private function collate($row)
	{
		$this->userTags[$row['usertagsId']] = preg_replace("/{(.*)}/U", "$1", 
				$this->html->dbToHtmlTidy($row['usertagsTag']));
		$this->sum[$row['usertagsId']] = $row['count'];
	}
// Process and display results
	private function process()
	{
		$lowestSum = current($this->sum);
		$highestSum = end($this->sum);
		foreach($this->userTags as $id => $name)
		{
			$colour = $this->common->colourText($lowestSum, $highestSum, $this->sum[$id]);
			$size = $this->common->sizeText($lowestSum, $highestSum, $this->sum[$id]);
			$links[] = $this->html->aBrowse($colour, $size, $name, 'index.php?' . 
				htmlentities('action=list_LISTSOMERESOURCES_CORE&method=usertagProcess&id=' . $id)) . 
				"&nbsp;[" . $this->sum[$id] . "]";
		}
		return join("&nbsp; ", $links);
	}
}
?>