<?php
/**********************************************************************************
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program;
if not, write to the
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2013
sirfragalot@users.sourceforge.net
**********************************************************************************/
/**
*	HELPMESSAGES class
*
*	Context help
*
*/
class HELPMESSAGES
{
private $vars;
private $help;
private $messages;
private $errors;
private $badInput;
private $html;
private $form;
private $icons;
private $session;

	public function __construct()
	{
		$this->vars = GLOBALS::getVars();
		$this->help = FACTORY_HELP::getInstance();
		$this->messages = FACTORY_MESSAGES::getInstance();
		$this->errors = FACTORY_ERRORS::getInstance();
		$this->badInput = FACTORY_BADINPUT::getInstance();
		$this->html = FACTORY_HTML::getInstance();
		$this->form = FACTORY_FORM::getInstance();
		$this->icons = FACTORY_LOADICONS::getInstance();
		$this->session = FACTORY_SESSION::getInstance();
		$this->icons->setupIcons('help');
		GLOBALS::setOutputHeading('');
	}
	public function init()
	{
		if(array_key_exists('message', $this->vars) && $this->vars['message'])
			GLOBALS::buildOutputString($this->help->text($this->vars['message']) . $this->html->p($this->form->closePopup()));
		else
		{
			$this->badInput->closeType = 'closePopup';
			$this->badInput->close($this->errors->text('inputError', 'missing'));
		}
		FACTORY_CLOSEPOPUP::getInstance();
	}
	public function createLink($message)
	{
		if(file_exists('templates/' . $this->session->getVar('setup_Template') . '/aside.txt'))
		{
			$jScript = "javascript:asideHelpToggle()";
			$this->template = FACTORY_TEMPLATE::getInstance();
			$this->template->tpl->assign('asideHelp', $this->help->text($message));
		}
		else
			$jScript = "javascript:coreOpenPopup('index.php?action=help_HELPMESSAGES_CORE&amp;message=" . $message . "', 80)";
		return $this->html->a($this->icons->helpLink, $this->icons->help, $jScript);
	}
}
?>