/**********************************************************************************
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms 
of the GNU General Public License as published by the Free Software Foundation; either 
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; 
if not, write to the 
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2013
sirfragalot@users.sourceforge.net

**********************************************************************************/
var type = 'select_';
if(coreGetElementById('search_Type') !== null)
	type = 'search_';
/**
* sets inner HTML of a DIV and restores the selected options in the select box
*/
function setDiv()
{
	var targetDivObj = coreGetElementById(A_OBJ[gateway.aobj_index].input.targetDiv);
	var targetOptionValues = new Array();
	var targetBoxObj = coreGetElementById(A_OBJ[gateway.aobj_index].input.targetBox);
// store selected options for later restoration
	if(targetBoxObj)
	{
		var len = targetBoxObj.options.length;
		for(var i = 0; i < len; i++)
		{
			if(targetBoxObj.options[i].selected && (targetBoxObj.options[i].value != 0)) // don't include 'IGNORE'
				targetOptionValues.push(targetBoxObj.options[i].value);
		}
	}
	targetDivObj.innerHTML = A_OBJ[gateway.aobj_index].input.targetContent;
// restore selected options
	targetBoxObj = coreGetElementById(A_OBJ[gateway.aobj_index].input.targetBox);
	if(targetBoxObj && targetOptionValues.length)
	{
		len = targetBoxObj.length
		var found = false;
		for(var i = 0; i < len; i++)
		{
			for(var index in targetOptionValues)
			{
				if(targetOptionValues[index] == targetBoxObj.options[i].value)
				{
					targetBoxObj.options[i].selected = true;
					found = true;
				}
			}
		}
	}
	if(found) // deselect IGNORE
		targetBoxObj.options[0].selected = false;
}
/**
* Transfer an option from the main keywords selectbox to the selected keywords selectbox
*/
function selectKeyword()
{
	var target = type + 'Keyword';
	var source = type + 'AvailableKeyword';
	coreSelectToSelect(target, source);
}
/**
* Transfer an option from the selected keywords selectbox to the main keywords selectbox
*/
function discardKeyword()
{
	var target = type + 'AvailableKeyword';
	var source = type + 'Keyword';
	coreSelectToSelect(target, source);
}
/**
* Transfer an option from the main usertags selectbox to the selected usertags selectbox
*/
function selectUserTag()
{
	var target = type + 'UserTag';
	var source = type + 'AvailableUserTag';
	coreSelectToSelect(target, source);
}
/**
* Transfer an option from the selected usertags selectbox to the main usertags selectbox
*/
function discardUserTag()
{
	var target = type + 'AvailableUserTag';
	var source = type + 'UserTag';
	coreSelectToSelect(target, source);
}
/**
* Transfer an option from the main categories selectbox to the selected categories selectbox
*/
function selectCategory()
{
	var target = type + 'Category';
	var source = type + 'AvailableCategory';
	coreSelectToSelect(target, source);
}
/**
* Transfer an option from the selected categories selectbox to the main categories selectbox
*/
function discardCategory()
{
	var target = type + 'AvailableCategory';
	var source = type + 'Category';
	coreSelectToSelect(target, source);
}
/**
* Transfer an option from the main subcategories selectbox to the selected subcategories selectbox
*/
function selectSubcategory()
{
	var target = type + 'Subcategory';
	var source = type + 'AvailableSubcategory';
	coreSelectToSelect(target, source);
}
/**
* Transfer an option from the selected subcategories selectbox to the main subcategories selectbox
*/
function discardSubcategory()
{
	var target = type + 'AvailableSubcategory';
	var source = type + 'Subcategory';
	coreSelectToSelect(target, source);
}
/**
* Transfer an option from the main collections selectbox to the selected collections selectbox
*/
function selectCollection()
{
	var target = type + 'Collection';
	var source = type + 'AvailableCollection';
	coreSelectToSelect(target, source);
}
/**
* Transfer an option from the selected collections selectbox to the main collections selectbox
*/
function discardCollection()
{
	var target = type + 'AvailableCollection';
	var source = type + 'Collection';
	coreSelectToSelect(target, source);
}
/**
* Transfer an option from the main creator selectbox to the selected creators selectbox
*/
function selectCreator()
{
	var target = type + 'Creator';
	var source = type + 'AvailableCreator';
	coreSelectToSelect(target, source);
}
/**
* Transfer an option from the selected creators selectbox to the main creators selectbox
*/
function discardCreator()
{
	var target = type + 'AvailableCreator';
	var source = type + 'Creator';
	coreSelectToSelect(target, source);
}
/**
* Transfer an option from the main publishers selectbox to the selected publishers selectbox
*/
function selectPublisher()
{
	var target = type + 'Publisher';
	var source = type + 'AvailablePublisher';
	coreSelectToSelect(target, source);
}
/**
* Transfer an option from the selected publishers selectbox to the main publishers selectbox
*/
function discardPublisher()
{
	var target = type + 'AvailablePublisher';
	var source = type + 'Publisher';
	coreSelectToSelect(target, source);
}
/**
* On submit, select all options in select boxes -- this allows PHP to pick up those options
*/
function selectAll()
{
	selectAllProcess('Keyword');
	selectAllProcess('UserTag');
	selectAllProcess('Category');
	selectAllProcess('Subcategory');
}
/**
* On submit, select all options in select boxes -- this allows PHP to pick up those options.  Extra options for select resources
*/
function selectAllSelect()
{
	selectAllProcess('Collection');
	selectAllProcess('Publisher');
	selectAllProcess('Creator');
}
/**
* Select selected options
*/
function selectAllProcess(box)
{
	var element = type + box;
	var obj = coreGetElementById(element);
	if(obj == null)
		return;
	for(i = obj.options.length - 1; i >= 0; i--)
		obj.options[i].selected = true;
}

