<?php
/**********************************************************************************
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program;
if not, write to the
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2011
sirfragalot@users.sourceforge.net
**********************************************************************************/
/**
* RESOURCEABSTRACT class
*
* View resource's abstract
*/
class RESOURCEABSTRACT
{
private $db;
private $vars;
private $session;
private $html;
private $messages;
private $user;
private $icons;
private $template;
private $common;
private $config;
private $cite;
private $userId;

	public function __construct()
	{
		$this->db = FACTORY_DB::getInstance();
		$this->vars = GLOBALS::getVars();
		$this->session = FACTORY_SESSION::getInstance();
		$this->html = FACTORY_HTML::getInstance();
		$this->messages = FACTORY_MESSAGES::getInstance();
		$this->user = FACTORY_USER::getInstance();
		$this->icons = FACTORY_LOADICONS::getInstance();
		$this->template = FACTORY_TEMPLATE::getInstance();
		$this->common = FACTORY_RESOURCECOMMON::getInstance();
		$this->config = FACTORY_CONFIG::getInstance();
		$this->cite = FACTORY_CITE::getInstance();
		$this->userId = $this->session->getVar('setup_UserId');
	}
// Display resource's abstract
	public function view($row)
	{
		$abstract = array();
		$write = $this->session->getVar('setup_Write') ? TRUE : FALSE;
		if(!$row['resourcetextAbstract'] && !$write)
			return $abstract;
		if($this->session->getVar("setup_Superadmin") || 
			($write && (!$this->config->WIKINDX_ORIGINATOR_EDITONLY || ($row['resourcemiscAddUserIdResource'] == $this->userId))))
		{
			if(!$row['resourcetextAbstract'])
			{
				$abstract['title'] = $this->messages->text("resources", "abstract");
				$abstract['editLink'] = $this->html->a($this->icons->addLink, $this->icons->add, 
					"index.php?action=metadata_EDITMETADATA_CORE" . 
					htmlentities("&type=abstractInit&id=" . $row['resourceId']));
				return $abstract;
			}
			else if($row['resourcetextAbstract'])
			{
				$abstract['editLink'] = $this->html->a($this->icons->editLink, $this->icons->edit, 
					"index.php?action=metadata_EDITMETADATA_CORE" . 
					htmlentities("&type=abstractInit&id=" . $row['resourceId']));
				$abstract['deleteLink'] = $this->html->a($this->icons->deleteLink, $this->icons->delete, 
					"index.php?action=metadata_EDITMETADATA_CORE" . 
					htmlentities("&type=abstractDeleteInit&id=" . $row['resourceId']));
			}
		}
		if($row['resourcetextAbstract'])
		{
			$abstract['title'] = $this->messages->text("resources", "abstract");
			list($abstract['userAdd'], $abstract['userEdit']) = $this->user->displayUserAddEdit($row, TRUE, 'abstract');
			$abstract['abstract'] = 
				$this->cite->parseCitations($this->common->doHighlight($this->html->dbToHtmlTidy($row['resourcetextAbstract'])), 'html');
		}
		return $abstract;
/*
// check for any citation strings
		include_once("core/cite/CITE.php");
		$cf = new CITE($this->db, $this->vars);
		$pString .= TABLE::td($cf->parseCitations($entry, 'html') . $userAddEdit, 'alternate1');
		if($write)
		{
			$editLink = $this->html->a("$viewEditLink", "&nbsp;" . $icons->edit . 
			"&nbsp;", "index.php?action=abstractEdit" . htmlentities("&id=" . $row['resourceId']));
			$pString .= TABLE::td($editLink, "alternate1", "right", "top");
		}
		$pString .= TABLE::trEnd();
		$pString .= TABLE::tableEnd();
		$pString .= $this->html->br() . "&nbsp;" . $this->html->br();
		return $abstract;
*/
	}
}
?>
