<?php
/**********************************************************************************
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program;
if not, write to the
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2011
sirfragalot@users.sourceforge.net
**********************************************************************************/
/**
* RESOURCENOTE class
*
* Deal with resource's notes
*/
class RESOURCENOTE
{
private $db;
private $vars;
private $session;
private $html;
private $messages;
private $user;
private $icons;
private $template;
private $common;
private $cite;
private $config;
private $userId;

	public function __construct()
	{
		$this->db = FACTORY_DB::getInstance();
		$this->vars = GLOBALS::getVars();
		$this->session = FACTORY_SESSION::getInstance();
		$this->html = FACTORY_HTML::getInstance();
		$this->messages = FACTORY_MESSAGES::getInstance();
		$this->user = FACTORY_USER::getInstance();
		$this->icons = FACTORY_LOADICONS::getInstance();
		$this->template = FACTORY_TEMPLATE::getInstance();
		$this->common = FACTORY_RESOURCECOMMON::getInstance();
		$this->cite = FACTORY_CITE::getInstance();
		$this->config = FACTORY_CONFIG::getInstance();
		$this->userId = $this->session->getVar('setup_UserId');
	}
// Display resource's note
	public function view($row)
	{
		$note = array();
		$write = $this->session->getVar('setup_Write') ? TRUE : FALSE;
		if(!$row['resourcetextNote'] && !$write)
			return $note;
		if($this->session->getVar("setup_Superadmin") || 
			($write && (!$this->config->WIKINDX_ORIGINATOR_EDITONLY || ($row['resourcemiscAddUserIdResource'] == $this->userId))))
		{
			if(!$row['resourcetextNote'])
			{
				$note['title'] = $this->messages->text("viewResource", "notes");
				$note['editLink'] = $this->html->a($this->icons->addLink, $this->icons->add, 
					"index.php?action=metadata_EDITMETADATA_CORE" . 
					htmlentities("&type=noteInit&id=" . $row['resourceId']));
				return $note;
			}
			else if($row['resourcetextNote'])
			{
				$note['editLink'] = $this->html->a($this->icons->editLink, $this->icons->edit, 
					"index.php?action=metadata_EDITMETADATA_CORE" . 
					htmlentities("&type=noteInit&id=" . $row['resourceId']));
				$note['deleteLink'] = $this->html->a($this->icons->deleteLink, $this->icons->delete, 
					"index.php?action=metadata_EDITMETADATA_CORE" . 
					htmlentities("&type=noteDeleteInit&id=" . $row['resourceId']));
			}
		}
		if($row['resourcetextNote'])
		{
			$note['title'] = $this->messages->text("viewResource", "notes");
			list($note['userAdd'], $note['userEdit']) = $this->user->displayUserAddEdit($row, TRUE, 'note');
			$note['note'] = 
				$this->cite->parseCitations($this->common->doHighlight($this->html->dbToHtmlTidy($row['resourcetextNote'])), 
				'html');
		}
		return $note;
/*
		$cf = new CITE($this->db, $this->vars);
		$pString .= TABLE::td($cf->parseCitations($entry, 'html') . $userAddEdit, 'alternate1');
		if($write)
		{
			$editLink = MISC::a("$viewEditLink", "&nbsp;" . $icons->edit . 
			"&nbsp;", "index.php?action=noteEdit" . htmlentities("&id=" . $row['resourceId']));
			$pString .= TABLE::td($editLink, "alternate1", "right", "top");
		}
		$pString .= TABLE::trEnd();
		$pString .= TABLE::tableEnd();
		$pString .= MISC::br() . "&nbsp;" . MISC::br();
		return $pString;
*/
	}
}
?>
