<?php
/**
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program;
if not, write to the
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2012
sirfragalot@users.sourceforge.net
*/
/**
* BADINPUT
*
* Display various error messages when input has gone wrong and, if necessary, redirect and close the script
*
* If an $object and $method are provided, it is expected that that method will exit the script tidily itself and will
* provide a means to print $error.
* Otherwise, $closeType calls the CLOSExxx object to exit (this is the default).
* 
* @version	1
*
*	@package wikindx4\core\navigation
*	@author Mark Grimshaw <sirfragalot@users.sourceforge.net>
*
*/
class BADINPUT
{
/** string */
public $closeType = FALSE;

/**
* BADINPUT
*/
	public function __construct()
	{
		$this->closeType = 'close'; // default
	}
/**
* Close and exit the current script operation.
*
* @param string $error Error message
* @param object $object Reference to object. Default is FALSE
* @param string $method Method in $object. Default is FALSE
*
*/
	public function close($error, &$object = FALSE, $method = FALSE)
	{
		if(is_array($error))
			$errors = $error;
		else                  
			$errors = array($error);
		foreach( $errors as $error )
		{
			if($object)
			{
				if(!$method)
				{
					print "Object defined but no method defined for object in BADINPUT";
					die;
				}
				else
					$object->{$method}($error);
			}
			else
			{
				GLOBALS::buildOutputString($error);
			}
		}
		$this->loadClose();
	}
/**
* Load the CLOSExxx object
*/
	private function loadClose()
	{
		if($this->closeType == 'close')
			FACTORY_CLOSE::getInstance();
		else if($this->closeType == 'closeNoMenu')
			FACTORY_CLOSENOMENU::getInstance();
		else if($this->closeType == 'closePopup')
			FACTORY_CLOSEPOPUP::getInstance();
		else
		{
			print "Incorrect CLOSE object defined in BADINPUT";
			die;
		}
	}
}
?>