<?php
/**
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program;
if not, write to the
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2012
sirfragalot@users.sourceforge.net
*/
/**
* NAVIGATE
*
* Configure, create and print menus
* 
* @version	1
*
*	@package wikindx4\core\navigation
*	@author Mark Grimshaw <sirfragalot@users.sourceforge.net>
*
*/
class NAVIGATE
{
/** object */
private $db;
/** object */
private $session;
/** object */
private $messages;

/**
* NAVIGATE
*/
	public function __construct()
	{
		$this->db = FACTORY_DB::getInstance();
		$this->session = FACTORY_SESSION::getInstance();
		$this->messages = FACTORY_MESSAGES::getInstance();
	}
/**
* Navigate back to a list view
*
* @param string $message
*/
	public function listView($message = FALSE)
	{
		$listCommon = FACTORY_LISTCOMMON::getInstance();
		$sql = base64_decode($this->session->getVar('sql_Stmt'));
		$queryString = $this->session->getVar('sql_LastMulti');
		if(!$queryString) // default
		{
			include_once("core/display/FRONT.php");
			$front = new FRONT($message); // __construct() runs on autopilot
			FACTORY_CLOSE::getInstance();
		}
		$countQuery = $this->db->query(base64_decode($this->session->getVar('sql_CountStmt')));
		if($this->session->getVar('sql_CountAlphaStmt'))
			$countAlphaQuery = $this->db->query(base64_decode($this->session->getVar('sql_CountAlphaStmt')));
		else
			$countAlphaQuery = FALSE;
		preg_match("/_(.*)_CORE/", $queryString, $match);
		if($match[1] == 'SELECTRESOURCES')
		{
			$listType = 'select';
			GLOBALS::setOutputHeading($this->messages->text("heading", "select"));
		}
		else if($match[1] == 'SELECTMETADATA')
		{
			$listType = 'select';
			$listCommon->metadata = TRUE;
			$listCommon->metadataText = unserialize(base64_decode($this->session->getVar('sql_MetadataText')));
			GLOBALS::setOutputHeading($this->messages->text("heading", "selectMeta"));
		}
		else if($match[1] == 'SEARCHRESOURCES')
		{
			$listType = 'search';
			GLOBALS::setOutputHeading($this->messages->text("heading", "search"));
		}
		else if($match[1] == 'SEARCHMETADATA')
		{
			$listType = 'search';
			$listCommon->metadata = TRUE;
			$listCommon->metadataText = unserialize(base64_decode($this->session->getVar('sql_MetadataText')));
			GLOBALS::setOutputHeading($this->messages->text("heading", "searchMeta"));
		}
		else if($match[1] == 'QUICKSEARCH')
		{
			$template = FACTORY_TEMPLATE::getInstance();
			include_once('core/modules/list/QUICKSEARCH.php');
			$qs = new QUICKSEARCH();
			$template->tpl->assign('resourceListSearchForm', $qs->init(FALSE, TRUE, TRUE));
			$listType = 'search';
			$listCommon->quickSearch = TRUE;
			GLOBALS::setOutputHeading($this->messages->text("heading", "search"));
		}
		else if(($match[1] == 'LISTRESOURCES') || ($match[1] == 'LISTSOMERESOURCES'))
		{
			$listType = 'list';
			GLOBALS::setOutputHeading($this->messages->text("heading", "list"));
		}
		else if($match[1] == 'BASKET')
		{
			GLOBALS::buildOutputString($message);
			include_once('core/modules/basket/BASKET.php');
			$basket = new BASKET();
			$basket->view();
			FACTORY_CLOSE::getInstance();
		}
		else // default
		{
			include_once("core/display/FRONT.php");
			$front = new FRONT($message); // __construct() runs on autopilot
			FACTORY_CLOSE::getInstance();
		}
		GLOBALS::buildOutputString($message);
		if($this->session->getVar($listType . '_DisplayAttachment'))
			$order = 'attachments';
		else
			$order = $this->session->getVar($listType . '_Order');
		if(!$order)
			$order = 'creator';
		$listCommon->pagingStyle($countQuery, $listType, $order, $queryString, $countAlphaQuery);
		$listCommon->display($sql, $listType);
	}
/**
* Navigate back to a single resource
*
* @param int $resourceId
* @param string $message
*/
	public function resource($resourceId, $message)
	{
		include_once('core/modules/resource/RESOURCEVIEW.php');
		$resource = new RESOURCEVIEW();
		$resource->init($resourceId, $message);
	}
}
?>