<?php
/**
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program;
if not, write to the
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2012
sirfragalot@users.sourceforge.net
*/
/**
* GLOBALS
*
* Rather than using the PHP $GLOBALS array for common variables, we store, set and access them from here.
* 
* @version	1
*
*	@package wikindx4\core\startup
*	@author Mark Grimshaw <sirfragalot@users.sourceforge.net>
*
*/
class GLOBALS
{
/**
* user input as either form data or querystring (normalized in ENVIRONMENT) is all stored in the $vars variable
*/
private static $vars = array();
/** array */
private static $dirtyVars = array();
/**
*  The db queries counter
*/
private static $WIKINDX_DB_QUERIES = 0;
/**
* The heading that is printed to the browser
*/
private static $WIKINDX_OUTPUT_HEADING = '';
/**
* The help link that is printed to the browser
*/
private static $WIKINDX_OUTPUT_HELP = '';
/**
* The output string that is printed to the browser
*/
private static $WIKINDX_OUTPUT_STRING = '';
/**
* The javascript that is printed to the browser
*/
private static $WIKINDX_OUTPUT_SCRIPT = '';

/**
*	GLOBALS
*/
	public function __construct()
	{
	}
/**
* Set $vars
*
* $cleanInput has been stripped of HTML etc.
* @param array $cleanInput
* @param array $dirtyInput
*/
	public static function setVars($cleanInput, $dirtyInput)
	{
		if(empty(self::$vars))
			self::$vars = $cleanInput;
		if(empty(self::$dirtyVars))
			self::$dirtyVars = $dirtyInput;
	}
/**
* Get $vars
*
* @return array
*/
	public static function getVars()
	{
		return self::$vars;
	}
/**
* Get $dirtyVars
*
* @return array
*/
	public static function getDirtyVars()
	{
		return self::$dirtyVars;
	}
/**
* Increment the DB query counter
*/
	public static function incrementDbQueries()
	{
		self::$WIKINDX_DB_QUERIES++;
	}
/** 
* Get the number of DB queries this script run
*
* @return int
*/
	public static function getDbQueries()
	{
		return self::$WIKINDX_DB_QUERIES;
	}
/**
* Set the browser output page heading
*
* @param string $heading
*/
	public static function setOutputHeading($heading)
	{
		self::$WIKINDX_OUTPUT_HEADING = $heading;
	}
/**
* Get the browser output page heading
*
* @return string
*/
	public static function getOutputHeading()
	{
		return self::$WIKINDX_OUTPUT_HEADING;
	}
/**
* Set the browser output page body
*
* This can be called multiple times with the $append sting being appended to.
*
* @param string $append
*/
	public static function buildOutputString($append)
	{
		self::$WIKINDX_OUTPUT_STRING .= $append;
	}
/**
* Get the browser output page body
*
* @return string
*/
	public static function getOutputString()
	{
		return self::$WIKINDX_OUTPUT_STRING;
	}
/**
* Set the browser help output
*
* @param string $help
*/
	public static function setOutputHelp($help)
	{
		self::$WIKINDX_OUTPUT_HELP = $help;
	}
/**
* Get the browser help output
*
* @return string
*/
	public static function getOutputHelp()
	{
		return self::$WIKINDX_OUTPUT_HELP;
	}
/**
* Set the output script
*
* @param string $script
*/
	public static function buildOutputScript($script)
	{
		self::$WIKINDX_OUTPUT_SCRIPT .= $script;
	}
/**
* Get the output script
*
* @return string
*/
	public static function getOutputScript()
	{
		return self::$WIKINDX_OUTPUT_SCRIPT;
	}
}
?>