<?php
/**
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program;
if not, write to the
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2013
sirfragalot@users.sourceforge.net
*/
/**
*	LOADCONFIG
*
*	Load config variables from the database
* 
* @version	1
*
*	@package wikindx4\core\startup
*	@author Mark Grimshaw <sirfragalot@users.sourceforge.net>
*
*/
class LOADCONFIG
{
/** object */
private $db;
/** object */
private $config;

/**
*	LOADCONFIG
*/
	public function __construct()
	{
		$this->db = FACTORY_DB::getInstance();
		$this->config = FACTORY_CONFIG::getInstance();
	}
/**
* Load various arrays into $this->config object
*/
	public function loadConfig()
	{
		$row = $this->db->fetchRow($this->db->select('config', array('configNoSort', 'configSearchFilter', 'configDenyReadOnly', 
			'configReadOnlyAccess', 'configOriginatorEditOnly', 'configGlobalEdit', 'configErrorReport', 'configPrintSql', 
			'configCaptchaPublicKey', 'configCaptchaPrivateKey')));
		if($row['configNoSort'])
			$this->config->WIKINDX_NOSORT = unserialize(base64_decode($row['configNoSort']));
		else
			$this->config->WIKINDX_NOSORT = array();
		if($row['configSearchFilter'])
			$this->config->WIKINDX_SEARCHFILTER = unserialize(base64_decode($row['configSearchFilter']));
		else
			$this->config->WIKINDX_SEARCHFILTER = array();
		$this->config->WIKINDX_DENY_READONLY = $row['configDenyReadOnly'] == 'Y' ? TRUE : FALSE;
		$this->config->WIKINDX_READONLYACCESS = $row['configReadOnlyAccess'] == 'Y' ? TRUE : FALSE;
		$this->config->WIKINDX_ORIGINATOR_EDITONLY = $row['configOriginatorEditOnly'] == 'Y' ? TRUE : FALSE;
		$this->config->WIKINDX_GLOBAL_EDIT = $row['configGlobalEdit'] == 'Y' ? TRUE : FALSE;
		$this->config->WIKINDX_ERROR_REPORTING = $row['configErrorReport'] == 'Y' ? TRUE : FALSE;
		$this->config->WIKINDX_PRINT_SQL = $row['configPrintSql'] == 'Y' ? TRUE : FALSE;
		if($row['configCaptchaPublicKey'])
			$this->config->WIKINDX_CAPTCHA_PUBLICKEY = $row['configCaptchaPublicKey'];
		if($row['configCaptchaPrivateKey'])
			$this->config->WIKINDX_CAPTCHA_PRIVATEKEY = $row['configCaptchaPrivateKey'];
/**
* WIKINDX_DEBUG_ERRORS and WIKINDX_DEBUG_SQL are set in config.php and, if TRUE, override 
* WIKINDX_ERROR_REPORTING and WIKINDX_PRINT_SQL which are set in the wikindx configure interface 
* and stored in database variables in the config table.
*/
		if($this->config->WIKINDX_ERROR_REPORTING || $this->config->WIKINDX_DEBUG_ERRORS)
		{
			if(version_compare(PHP_VERSION, '5.3.0', '<')) 
				error_reporting(E_ALL & ~E_STRICT);
			else
				error_reporting(E_ALL & ~E_DEPRECATED & ~E_STRICT);
			ini_set('display_errors', 1);
			ini_set('track_errors', 'On');
		}
		else
		{
			if(version_compare(PHP_VERSION, '5.3.0', '<')) 
				error_reporting(~E_STRICT);
			else
				error_reporting(~E_DEPRECATED & ~E_STRICT);
			ini_set('display_errors', 'Off');
			ini_set('track_errors', 'Off');
			error_reporting(0);
		}
		if($this->config->WIKINDX_DEBUG_SQL)
			$this->config->WIKINDX_PRINT_SQL = TRUE;
	}
}
?>