<?php
/**********************************************************************************
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms 
of the GNU General Public License as published by the Free Software Foundation; either 
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; 
if not, write to the 
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2012
sirfragalot@users.sourceforge.net
**********************************************************************************/


session_start();
if(isset($_SESSION))
{
	chdir($_SESSION['wikindxBasePath']); // tinyMCE changes the phpbasepath
	$script = '<script type="text/javascript" src="../../tiny_mce_popup.js"></script>
		<script type="text/javascript" src="../../utils/mctabs.js"></script>
		<script type="text/javascript" src="../../utils/form_utils.js"></script>
		<script type="text/javascript" src="../../utils/validate.js"></script>
		<script type="text/javascript" src="js/advlink.js"></script>
		<script type="text/javascript" src="js/wikindxLinkdialog.js"></script>';
	include_once("core/startup/GLOBALS.php");
	GLOBALS::buildOutputScript($script);
	$class = new linkDialog();
}
else
	echo 'Session error';
		
class linkDialog
{
private $messages;
private $form;
private $html;

	function __construct()
	{
		include_once("core/startup/FACTORY.php");
		include_once("core/startup/GLOBALS.php");
		$this->messages = FACTORY_MESSAGES::getInstance();
		$this->form = FACTORY_FORM::getInstance();
		$this->html = FACTORY_HTML::getInstance();
		$this->linkDialogue();
	}
	
	
/*
* Add link dialogue
* @author Mark Grimshaw
* @version 1
* @return string
*/
	private function linkDialogue()
	{
		$pString = $this->html->h($this->messages->text('tinymce', "headingAddLink"), FALSE, 3);
		$this->form->insertJscriptAction = "onsubmit=\"insertAction();return false;\"";
		$pString .= $this->form->formHeaderVisibleAction("dialog.php", "insertLink");
		$pString .= $this->form->hidden("method", "addImage");
		$linkPath = $this->messages->text('tinymce', "linkPath");
$pString .= <<< END
	<fieldset>

		<table border="0" cellpadding="4" cellspacing="0" role="presentation">
			<tr>
				<td class="nowrap"><label id="hreflabel" for="href">$linkPath</label></td>
					<td><table border="0" cellspacing="0" cellpadding="0">
				<tr>
					<td><input id="href" name="href" type="text" class="mceFocus" value="" onchange="selectByValue(this.form,'linklisthref',this.value);" aria-required="true" /></td>
					<td id="hrefbrowsercontainer">&nbsp;</td>
				</tr>
				</table></td>
			</tr>
		</table>
	</fieldset>
END;
		$pString .= $this->html->p($this->form->formSubmit('Submit', FALSE, 'insert'));
		$pString .= $this->form->formEnd();
		GLOBALS::buildOutputString($pString);
		FACTORY_CLOSEPOPUP::getInstance();
	}

/*
* Add link dialogue
* @author Mark Grimshaw
* @version 1
* @return string
*/
	private function linkDialogueOld()
	{
		$pString = $this->html->h($this->messages->text('tinymce', "headingAddLink"), FALSE, 3);
		$this->form->insertJscriptAction = "onsubmit=\"return linkDialog();\"";
		$pString .= $this->form->formHeaderVisibleAction("dialog.php", "insertLink");
		$pString .= $this->form->hidden("method", "addImage");
		$pString .= $this->html->p($this->form->textInput($this->messages->text('tinymce', "linkPath"), 'linkPath', 'http://', 50));
		$pString .= $this->html->p($this->form->textInput($this->messages->text('tinymce', "linkText"), 'linkText', FALSE, 50));
		$pString .= $this->html->p($this->form->formSubmit('Submit', FALSE, 'insert'));
		$pString .= $this->form->formEnd();
		GLOBALS::buildOutputString($pString);
		FACTORY_CLOSEPOPUP::getInstance();
	}
}
?>
