<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
	<title>Special Characters</title>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	
	<style type="text/css">
	body {
		background-color:#FFF;
	}
	
	#spcharTable {
		border: 1px solid black;
		margin-right: auto;
		margin-left: auto;
		border-spacing:0;
		border-collapse:collapse;
	}
	
	#spcharTable td {
		text-align: center;
		border: 1px solid gray;
		padding : 2px;
		font-size : 16px;
		cursor:default;
	}
	
	#spcharTable td:hover {
		background-color: red;
		color: #FFF;
		cursor:pointer;
	}
	
	#spcharTable td.charsetHeading {
		background-color: #EEE;
		border-top: 2px solid gray;
		border-bottom: 2px solid gray;
	}
	
	#spcharTable td.charsetHeading:hover {
		background-color: #EEE;
		color: #000;
		cursor:default;
	}
	
	#spcharTable td.emptyCell:hover {
		background-color: #FFF;
		color: #000;
		cursor:default;
	}
	
	.links {
		float : left;
		padding : 0 10px 0 0;
	}
	</style>
	
	<script language="JavaScript" type="text/javascript">
	<!--
	var spChar = new Array();
	var text = new Array;
	var htmlChar;
	function selectSpChar(idChar) {
		if(idChar != '')
		{
			htmlChar = '&#' + idChar + ';';
			spChar.push(htmlChar);
			text.push(String.fromCharCode(idChar));
			parent.nav.document.getElementById("textBox").innerHTML = parent.nav.document.getElementById("textBox").innerHTML + htmlChar;
		}
	}
	
	function InitSpChar() {
		if (document.getElementsByTagName)
			var x = document.getElementsByTagName('TD');
		else if (document.all)
			var x = document.all.tags('TD');
		for (var i=0; i < x.length; i++) {
			x[i].onclick = click;
		}
	}
	
	function click() {
		selectSpChar(this.id);
	}
	//-->
	</script>
</head>
<body onLoad="InitSpChar()">
<table id="spCharTable">
<?php


// Create unicode tables.  Which characters are available is modelled on what is available in my OO.org 2 beta....
function bodyCharsetTable($numColumns, $charsetArray, $name, $title)
{
	$lString = "";
	$lString .= "<tr>\n\t<td class=\"charsetHeading\" colspan=\"$numColumns\"><a name=\"$name\">$title</td>\n</tr>\n";
	
	foreach (array_chunk($charsetArray, $numColumns) as $lineArray)
	{
		$lString .= "<tr>\n";
		
		foreach ($lineArray as $char)
		{
			$lString .= "\t<td id=\"$char\">&#$char;</td>\n";
		}
		
		$index = count($lineArray);
		if($index < $numColumns)
			$lString .= "\t<td class=\"emptyCell\" colspan=\"" . ($numColumns - $index) . "\">&nbsp;</td>\n";
		
		$lString .= "</tr>\n";
	}	
	
	return $lString;
}

function bodyCharsetTableCombiningDiacriticalMarks($numColumns, $charsetArray, $name, $title)
{
	$lString = "";
	$lString .= "<tr>\n\t<td class=\"charsetHeading\" colspan=\"$numColumns\"><a name=\"$name\">$title <span style=\"color:red;\">*</span></td>\n</tr>\n";
	
	foreach (array_chunk($charsetArray, $numColumns) as $lineArray)
	{
		$lString .= "<tr>\n";
		
		foreach ($lineArray as $char)
		{
			switch ($char) {
				case 768:
					$lString .= "\t<td id=\"$char\">̀o</td>\n";
					break;
				case 769:
					$lString .= "\t<td id=\"$char\">́o</td>\n";
					break;
				case 771:
					$lString .= "\t<td id=\"$char\">̃o</td>\n";
					break;
				case 777:
					$lString .= "\t<td id=\"$char\">̉o</td>\n";
					break;
				case 803:
					$lString .= "\t<td id=\"$char\">̣o</td>\n";
					break;
				default:
					$lString .= "\t<td id=\"$char\">&#$char;</td>\n";
			}
		}
		
		$index = count($lineArray);
		if($index < $numColumns)
			$lString .= "\t<td class=\"emptyCell\" colspan=\"" . ($numColumns - $index) . "\">&nbsp</td>\n";
		
		$lString .= "</tr>\n";
	}	
	
	return $lString;
}

$numColumns = 20;

// Basic Latin
$charsetArray = array();
for($char = 33; $char <= 126; $char++)
{
	$charsetArray[] = $char;
}

print bodyCharsetTable($numColumns, $charsetArray, "basicLatin", "Basic Latin");


// Latin 1 Supplement
$charsetArray = array();
for($char = 161; $char <= 255; $char++)
{
	if(($char == 173) || ($char == 144) || ($char == 157))
		continue;
	
	$charsetArray[] = $char;
}

print bodyCharsetTable($numColumns, $charsetArray, "latin1", "Latin 1");


// Latin Extended A
$charsetArray = array();
for($char = 256; $char <= 383; $char++)
{
	
	$charsetArray[] = $char;
}

print bodyCharsetTable($numColumns, $charsetArray, "latinExtendedA", "Latin Extended A");


// Latin Extended B
$charsetArray = array();
for($char = 399; $char <= 511; $char++)
{
	if(($char == 400) || ($char == 401) || (($char >= 402) && ($char <= 415))
	 || (($char >= 418) && ($char <= 430)) || (($char >= 433) && ($char <= 461))
	 || (($char >= 477) && ($char <= 505)))
		continue;
	
	$charsetArray[] = $char;
}

print bodyCharsetTable($numColumns, $charsetArray, "latinExtendedB", "Latin Extended B");


// IPA Extensions
$charsetArray = array();
for($char = 601; $char <= 601; $char++)
{
	
	$charsetArray[] = $char;
}

print bodyCharsetTable($numColumns, $charsetArray, "IPA", "IPA Extensions");


// Spacing Modifier Letters
$charsetArray = array();
for($char = 710; $char <= 733; $char++)
{
	if(($char >= 712) && ($char <= 727))
		continue;
	
	$charsetArray[] = $char;
}

print bodyCharsetTable($numColumns, $charsetArray, "spacingModifierLetters", "Spacing Modifier Letters");


// Combining Diacritical Marks
$charsetArray = array();
for($char = 768; $char <= 803; $char++)
{
	if(($char != 768) && ($char != 769) && ($char != 771) && ($char != 777) && ($char != 803))
		continue;
	
	$charsetArray[] = $char;
}

print bodyCharsetTableCombiningDiacriticalMarks($numColumns, $charsetArray, "combiningDiacriticalMarks", "Combining Diacritical Marks");


// Greek and Coptic
$charsetArray = array();
for($char = 894; $char <= 974; $char++)
{
	if((($char >= 895) && ($char <= 899)) || ($char == 907) || ($char == 909) || ($char == 930))
		continue;
	
	$charsetArray[] = $char;
}

print bodyCharsetTable($numColumns, $charsetArray, "basicGreek", "Basic Greek");


// Cyrillic
$charsetArray = array();
for($char = 1025; $char <= 1257; $char++)
{
	if(($char == 1120) || ($char == 1121) || (($char >= 1124) && ($char <= 1129))
	 || (($char >= 1132) && ($char <= 1137)) || (($char >= 1142) && ($char <= 1167)) || ($char == 1221) 
	 || ($char == 1222) || ($char == 1225)  || ($char == 1226)  || ($char == 1229) 
	 || ($char == 1230) || (($char >= 1234) && ($char <= 1237)) || ($char == 1239)
	 || (($char >= 1242) && ($char <= 1249)) || (($char >= 1252) && ($char <= 1255)))
		continue;
	
	$charsetArray[] = $char;
}

print bodyCharsetTable($numColumns, $charsetArray, "cyrillic", "Cyrillic");


// Basic Hebrew
$charsetArray = array();
for($char = 1456; $char <= 1524; $char++)
{
	if((($char >= 1476) && ($char <= 1487)) || (($char >= 1515) && ($char <= 1519)))
		continue;
	
	$charsetArray[] = $char;
}

print bodyCharsetTable($numColumns, $charsetArray, "basicHebrew", "Basic Hebrew");


// Arabic
$charsetArray = array();
for($char = 1548; $char <= 1790; $char++)
{
	if((($char >= 1549) && ($char <= 1562)) || (($char >= 1564) && ($char <= 1566)) || ($char == 1568)
	|| (($char >= 1595) && ($char <= 1599)) || (($char >= 1625) && ($char <= 1631))
	 || ($char == 1774) || ($char == 1775))
		continue;
	
	$charsetArray[] = $char;
}

print bodyCharsetTable($numColumns, $charsetArray, "arabic", "Arabic");


// Latin Extended Additional
$charsetArray = array();
for($char = 7808; $char <= 7929; $char++)
{
	if(($char >= 7814) && ($char <= 7839))
		continue;
	
	$charsetArray[] = $char;
}

print bodyCharsetTable($numColumns, $charsetArray, "latinExtendedAdditional", "Latin Extended Additional");


// General Punctuation
$charsetArray = array();
for($char = 8204; $char <= 8260; $char++)
{
	if(($char == 8208) || ($char == 8209) || ($char == 8214) || ($char == 8223) || ($char == 8227)
	 || ($char == 8228) || ($char == 8229) || (($char >= 8231) && ($char <= 8239)) || ($char == 8241)
	 || (($char >= 8244) && ($char <= 8248)) || ($char == 8251) || (($char >= 8253) && ($char <= 8259)))
		continue;
	
	$charsetArray[] = $char;
}

print bodyCharsetTable($numColumns, $charsetArray, "generalPunctuation", "General Punctuation");


// Currency and Letterlike Symbols" (same internal link as above)
$charsetArray = array();
for($char = 8355; $char <= 8364; $char++)
{
	if(($char == 8357) || ($char == 8358) || ($char == 8360) || ($char == 8361))
		continue;
	
	$charsetArray[] = $char;
}

for($char = 8453; $char <= 8494; $char++)
{
	if(($char != 8453) && ($char != 8467) && ($char != 8470) && ($char != 8482) && ($char != 8486)
	 && ($char != 8494))
		continue;
	
	$charsetArray[] = $char;
}

print bodyCharsetTable($numColumns, $charsetArray, "currencyLetter", "Currency and Letterlike Symbols");


// Number Forms and Arrows (same internal link as above)
$charsetArray = array();
for($char = 8531; $char <= 8542; $char++)
{
	if(($char != 8531) && ($char != 8532) && ($char != 8539) && ($char != 8540) && ($char != 8541)
	 && ($char != 8542))
		continue;
	
	$charsetArray[] = $char;
}

for($char = 8592; $char <= 8616; $char++)
{
	if(($char != 8592) && ($char != 8593)&& ($char != 8594) && ($char != 8595) && ($char != 8596)
	 && ($char != 8597) && ($char != 8616))
		continue;
	
	$charsetArray[] = $char;
}

print bodyCharsetTable($numColumns, $charsetArray, "numberArrow", "Number Forms and Arrows");


// Mathematical Operators
$charsetArray = array();
for($char = 8706; $char <= 8805; $char++)
{
	if((($char >= 8707) && ($char <= 8709)) || (($char >= 8711) && ($char <= 8718))
	|| ($char == 2210) || ($char == 8723) || ($char == 8724) || (($char >= 8726) && ($char <= 8728))
	|| (($char >= 8731) && ($char <= 8733)) || (($char >= 8736) && ($char <= 8744)) || ($char == 8746)
	|| (($char >= 8748) && ($char <= 8775)) || (($char >= 8777) && ($char <= 8800))
	|| ($char == 8802) || ($char == 8803))
		continue;
	
	$charsetArray[] = $char;
}

print bodyCharsetTable($numColumns, $charsetArray, "mathematicalOperator", "Mathematical Operators");


// alphabetic Presentation Forms
$charsetArray = array();
for($char = 64257; $char <= 64335; $char++)
{
	if((($char >= 64259) && ($char <= 64284)) || (($char >= 64289) && ($char <= 64297)) || ($char == 64311)
	 || ($char == 64317) || ($char == 64319) || ($char == 64322) || ($char == 64325))
		continue;
	
	$charsetArray[] = $char;
}

print bodyCharsetTable($numColumns, $charsetArray, "alphabeticPresentation", "Alphabetic Presentation Forms");


// Arabic Presentation Forms A
$charsetArray = array();
for($char = 64336; $char <= 65010; $char++)
{
	if((($char >= 64434) && ($char <= 64466)) || (($char >= 64488) && ($char <= 64507))
	 || (($char >= 64512) && ($char <= 64605)) || (($char >= 64611) && ($char <= 64829))
	 || (($char >= 64832) && ($char <= 645009)))
		continue;
	
	$charsetArray[] = $char;
}

print bodyCharsetTable($numColumns, $charsetArray, "arabicPresentationA", "Arabic Presentation Forms A");


// Arabic Presentation Forms B
$charsetArray = array();
for($char = 65152; $char <= 65276; $char++)
{
	$charsetArray[] = $char;
}

print bodyCharsetTable($numColumns, $charsetArray, "arabicPresentationB", "Arabic Presentation Forms B");

?>
</tr>
</table>
</body>
</html>
