<?php
/**
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program;
if not, write to the
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2012
sirfragalot@users.sourceforge.net
*/
/**
* URL
*
* Common methods for handling URLs.
* 
* @version	1
*
*	@package wikindx4\core\urls
*	@author Mark Grimshaw <sirfragalot@users.sourceforge.net>
*
*/
class URL
{
/** object */
private $session;

/**
* URL
*/
	public function __construct()
	{
		$this->session = FACTORY_SESSION::getInstance();
	}
/**
* grab URLs from provided db field value
*
* Function does: unserialize(base64_decode($field))
*
* @param string $field
* @return array
*/
	public function getUrls($field)
	{
		$array = unserialize(base64_decode($field));
		if(!is_array($array))
			$array = array(); // empty array
		return $array;
	}
/**
* reduce the size of long URL to keep web browser display tidy
*
* @param string $text
* @param int $limit Default is FALSE
* @return string
*/
	public function reduceUrl($text, $limit = FALSE)
	{
		if(!$limit)
			$limit = $this->session->getVar("setup_StringLimit");
		if(($limit != -1) && (($count = strlen($text)) > $limit))
		{
			$start = floor(($limit/2) - 2);
			$length = $count - (2 * $start);
			$text = substr_replace($text, " ... ", $start, $length);
		}
		return $text;
	}
}
?>